#include "ipfix_iana.h"

#ifdef __cplusplus
extern "C" {
#endif

struct ipfix_identifier ipfixids_iana[] = {
/* IANA registry */
  { IPFIX_TYPEID_octetDeltaCount                         , IPFIX_BYTES_unsigned64          ,     0, "octetDeltaCount"                       , IPFIX_DATA_TYPE_octetDeltaCount                          },
  { IPFIX_TYPEID_packetDeltaCount                        , IPFIX_BYTES_unsigned64          ,     0, "packetDeltaCount"                      , IPFIX_DATA_TYPE_packetDeltaCount                         },
  { IPFIX_TYPEID_deltaFlowCount                          , IPFIX_BYTES_unsigned64          ,     0, "deltaFlowCount"                        , IPFIX_DATA_TYPE_deltaFlowCount                           },
  { IPFIX_TYPEID_protocolIdentifier                      , IPFIX_BYTES_unsigned8           ,     0, "protocolIdentifier"                    , IPFIX_DATA_TYPE_protocolIdentifier                       },
  { IPFIX_TYPEID_ipClassOfService                        , IPFIX_BYTES_unsigned8           ,     0, "ipClassOfService"                      , IPFIX_DATA_TYPE_ipClassOfService                         },
  { IPFIX_TYPEID_tcpControlBits                          , IPFIX_BYTES_unsigned16          ,     0, "tcpControlBits"                        , IPFIX_DATA_TYPE_tcpControlBits                           },
  { IPFIX_TYPEID_sourceTransportPort                     , IPFIX_BYTES_unsigned16          ,     0, "sourceTransportPort"                   , IPFIX_DATA_TYPE_sourceTransportPort                      },
  { IPFIX_TYPEID_sourceIPv4Address                       , IPFIX_BYTES_ipv4Address         ,     0, "sourceIPv4Address"                     , IPFIX_DATA_TYPE_sourceIPv4Address                        },
  { IPFIX_TYPEID_sourceIPv4PrefixLength                  , IPFIX_BYTES_unsigned8           ,     0, "sourceIPv4PrefixLength"                , IPFIX_DATA_TYPE_sourceIPv4PrefixLength                   },
  { IPFIX_TYPEID_ingressInterface                        , IPFIX_BYTES_unsigned32          ,     0, "ingressInterface"                      , IPFIX_DATA_TYPE_ingressInterface                         },
  { IPFIX_TYPEID_destinationTransportPort                , IPFIX_BYTES_unsigned16          ,     0, "destinationTransportPort"              , IPFIX_DATA_TYPE_destinationTransportPort                 },
  { IPFIX_TYPEID_destinationIPv4Address                  , IPFIX_BYTES_ipv4Address         ,     0, "destinationIPv4Address"                , IPFIX_DATA_TYPE_destinationIPv4Address                   },
  { IPFIX_TYPEID_destinationIPv4PrefixLength             , IPFIX_BYTES_unsigned8           ,     0, "destinationIPv4PrefixLength"           , IPFIX_DATA_TYPE_destinationIPv4PrefixLength              },
  { IPFIX_TYPEID_egressInterface                         , IPFIX_BYTES_unsigned32          ,     0, "egressInterface"                       , IPFIX_DATA_TYPE_egressInterface                          },
  { IPFIX_TYPEID_ipNextHopIPv4Address                    , IPFIX_BYTES_ipv4Address         ,     0, "ipNextHopIPv4Address"                  , IPFIX_DATA_TYPE_ipNextHopIPv4Address                     },
  { IPFIX_TYPEID_bgpSourceAsNumber                       , IPFIX_BYTES_unsigned32          ,     0, "bgpSourceAsNumber"                     , IPFIX_DATA_TYPE_bgpSourceAsNumber                        },
  { IPFIX_TYPEID_bgpDestinationAsNumber                  , IPFIX_BYTES_unsigned32          ,     0, "bgpDestinationAsNumber"                , IPFIX_DATA_TYPE_bgpDestinationAsNumber                   },
  { IPFIX_TYPEID_bgpNextHopIPv4Address                   , IPFIX_BYTES_ipv4Address         ,     0, "bgpNextHopIPv4Address"                 , IPFIX_DATA_TYPE_bgpNextHopIPv4Address                    },
  { IPFIX_TYPEID_postMCastPacketDeltaCount               , IPFIX_BYTES_unsigned64          ,     0, "postMCastPacketDeltaCount"             , IPFIX_DATA_TYPE_postMCastPacketDeltaCount                },
  { IPFIX_TYPEID_postMCastOctetDeltaCount                , IPFIX_BYTES_unsigned64          ,     0, "postMCastOctetDeltaCount"              , IPFIX_DATA_TYPE_postMCastOctetDeltaCount                 },
  { IPFIX_TYPEID_flowEndSysUpTime                        , IPFIX_BYTES_unsigned32          ,     0, "flowEndSysUpTime"                      , IPFIX_DATA_TYPE_flowEndSysUpTime                         },
  { IPFIX_TYPEID_flowStartSysUpTime                      , IPFIX_BYTES_unsigned32          ,     0, "flowStartSysUpTime"                    , IPFIX_DATA_TYPE_flowStartSysUpTime                       },
  { IPFIX_TYPEID_postOctetDeltaCount                     , IPFIX_BYTES_unsigned64          ,     0, "postOctetDeltaCount"                   , IPFIX_DATA_TYPE_postOctetDeltaCount                      },
  { IPFIX_TYPEID_postPacketDeltaCount                    , IPFIX_BYTES_unsigned64          ,     0, "postPacketDeltaCount"                  , IPFIX_DATA_TYPE_postPacketDeltaCount                     },
  { IPFIX_TYPEID_minimumIpTotalLength                    , IPFIX_BYTES_unsigned64          ,     0, "minimumIpTotalLength"                  , IPFIX_DATA_TYPE_minimumIpTotalLength                     },
  { IPFIX_TYPEID_maximumIpTotalLength                    , IPFIX_BYTES_unsigned64          ,     0, "maximumIpTotalLength"                  , IPFIX_DATA_TYPE_maximumIpTotalLength                     },
  { IPFIX_TYPEID_sourceIPv6Address                       , IPFIX_BYTES_ipv6Address         ,     0, "sourceIPv6Address"                     , IPFIX_DATA_TYPE_sourceIPv6Address                        },
  { IPFIX_TYPEID_destinationIPv6Address                  , IPFIX_BYTES_ipv6Address         ,     0, "destinationIPv6Address"                , IPFIX_DATA_TYPE_destinationIPv6Address                   },
  { IPFIX_TYPEID_sourceIPv6PrefixLength                  , IPFIX_BYTES_unsigned8           ,     0, "sourceIPv6PrefixLength"                , IPFIX_DATA_TYPE_sourceIPv6PrefixLength                   },
  { IPFIX_TYPEID_destinationIPv6PrefixLength             , IPFIX_BYTES_unsigned8           ,     0, "destinationIPv6PrefixLength"           , IPFIX_DATA_TYPE_destinationIPv6PrefixLength              },
  { IPFIX_TYPEID_flowLabelIPv6                           , IPFIX_BYTES_unsigned32          ,     0, "flowLabelIPv6"                         , IPFIX_DATA_TYPE_flowLabelIPv6                            },
  { IPFIX_TYPEID_icmpTypeCodeIPv4                        , IPFIX_BYTES_unsigned16          ,     0, "icmpTypeCodeIPv4"                      , IPFIX_DATA_TYPE_icmpTypeCodeIPv4                         },
  { IPFIX_TYPEID_igmpType                                , IPFIX_BYTES_unsigned8           ,     0, "igmpType"                              , IPFIX_DATA_TYPE_igmpType                                 },
  { IPFIX_TYPEID_flowActiveTimeout                       , IPFIX_BYTES_unsigned16          ,     0, "flowActiveTimeout"                     , IPFIX_DATA_TYPE_flowActiveTimeout                        },
  { IPFIX_TYPEID_flowIdleTimeout                         , IPFIX_BYTES_unsigned16          ,     0, "flowIdleTimeout"                       , IPFIX_DATA_TYPE_flowIdleTimeout                          },
  { IPFIX_TYPEID_exportedOctetTotalCount                 , IPFIX_BYTES_unsigned64          ,     0, "exportedOctetTotalCount"               , IPFIX_DATA_TYPE_exportedOctetTotalCount                  },
  { IPFIX_TYPEID_exportedMessageTotalCount               , IPFIX_BYTES_unsigned64          ,     0, "exportedMessageTotalCount"             , IPFIX_DATA_TYPE_exportedMessageTotalCount                },
  { IPFIX_TYPEID_exportedFlowRecordTotalCount            , IPFIX_BYTES_unsigned64          ,     0, "exportedFlowRecordTotalCount"          , IPFIX_DATA_TYPE_exportedFlowRecordTotalCount             },
  { IPFIX_TYPEID_sourceIPv4Prefix                        , IPFIX_BYTES_ipv4Address         ,     0, "sourceIPv4Prefix"                      , IPFIX_DATA_TYPE_sourceIPv4Prefix                         },
  { IPFIX_TYPEID_destinationIPv4Prefix                   , IPFIX_BYTES_ipv4Address         ,     0, "destinationIPv4Prefix"                 , IPFIX_DATA_TYPE_destinationIPv4Prefix                    },
  { IPFIX_TYPEID_mplsTopLabelType                        , IPFIX_BYTES_unsigned8           ,     0, "mplsTopLabelType"                      , IPFIX_DATA_TYPE_mplsTopLabelType                         },
  { IPFIX_TYPEID_mplsTopLabelIPv4Address                 , IPFIX_BYTES_ipv4Address         ,     0, "mplsTopLabelIPv4Address"               , IPFIX_DATA_TYPE_mplsTopLabelIPv4Address                  },
  { IPFIX_TYPEID_minimumTTL                              , IPFIX_BYTES_unsigned8           ,     0, "minimumTTL"                            , IPFIX_DATA_TYPE_minimumTTL                               },
  { IPFIX_TYPEID_maximumTTL                              , IPFIX_BYTES_unsigned8           ,     0, "maximumTTL"                            , IPFIX_DATA_TYPE_maximumTTL                               },
  { IPFIX_TYPEID_fragmentIdentification                  , IPFIX_BYTES_unsigned32          ,     0, "fragmentIdentification"                , IPFIX_DATA_TYPE_fragmentIdentification                   },
  { IPFIX_TYPEID_postIpClassOfService                    , IPFIX_BYTES_unsigned8           ,     0, "postIpClassOfService"                  , IPFIX_DATA_TYPE_postIpClassOfService                     },
  { IPFIX_TYPEID_sourceMacAddress                        , IPFIX_BYTES_macAddress          ,     0, "sourceMacAddress"                      , IPFIX_DATA_TYPE_sourceMacAddress                         },
  { IPFIX_TYPEID_postDestinationMacAddress               , IPFIX_BYTES_macAddress          ,     0, "postDestinationMacAddress"             , IPFIX_DATA_TYPE_postDestinationMacAddress                },
  { IPFIX_TYPEID_vlanId                                  , IPFIX_BYTES_unsigned16          ,     0, "vlanId"                                , IPFIX_DATA_TYPE_vlanId                                   },
  { IPFIX_TYPEID_postVlanId                              , IPFIX_BYTES_unsigned16          ,     0, "postVlanId"                            , IPFIX_DATA_TYPE_postVlanId                               },
  { IPFIX_TYPEID_ipVersion                               , IPFIX_BYTES_unsigned8           ,     0, "ipVersion"                             , IPFIX_DATA_TYPE_ipVersion                                },
  { IPFIX_TYPEID_flowDirection                           , IPFIX_BYTES_unsigned8           ,     0, "flowDirection"                         , IPFIX_DATA_TYPE_flowDirection                            },
  { IPFIX_TYPEID_ipNextHopIPv6Address                    , IPFIX_BYTES_ipv6Address         ,     0, "ipNextHopIPv6Address"                  , IPFIX_DATA_TYPE_ipNextHopIPv6Address                     },
  { IPFIX_TYPEID_bgpNextHopIPv6Address                   , IPFIX_BYTES_ipv6Address         ,     0, "bgpNextHopIPv6Address"                 , IPFIX_DATA_TYPE_bgpNextHopIPv6Address                    },
  { IPFIX_TYPEID_ipv6ExtensionHeaders                    , IPFIX_BYTES_unsigned32          ,     0, "ipv6ExtensionHeaders"                  , IPFIX_DATA_TYPE_ipv6ExtensionHeaders                     },
  { IPFIX_TYPEID_mplsTopLabelStackSection                , IPFIX_BYTES_octetArray          ,     0, "mplsTopLabelStackSection"              , IPFIX_DATA_TYPE_mplsTopLabelStackSection                 },
  { IPFIX_TYPEID_mplsLabelStackSection2                  , IPFIX_BYTES_octetArray          ,     0, "mplsLabelStackSection2"                , IPFIX_DATA_TYPE_mplsLabelStackSection2                   },
  { IPFIX_TYPEID_mplsLabelStackSection3                  , IPFIX_BYTES_octetArray          ,     0, "mplsLabelStackSection3"                , IPFIX_DATA_TYPE_mplsLabelStackSection3                   },
  { IPFIX_TYPEID_mplsLabelStackSection4                  , IPFIX_BYTES_octetArray          ,     0, "mplsLabelStackSection4"                , IPFIX_DATA_TYPE_mplsLabelStackSection4                   },
  { IPFIX_TYPEID_mplsLabelStackSection5                  , IPFIX_BYTES_octetArray          ,     0, "mplsLabelStackSection5"                , IPFIX_DATA_TYPE_mplsLabelStackSection5                   },
  { IPFIX_TYPEID_mplsLabelStackSection6                  , IPFIX_BYTES_octetArray          ,     0, "mplsLabelStackSection6"                , IPFIX_DATA_TYPE_mplsLabelStackSection6                   },
  { IPFIX_TYPEID_mplsLabelStackSection7                  , IPFIX_BYTES_octetArray          ,     0, "mplsLabelStackSection7"                , IPFIX_DATA_TYPE_mplsLabelStackSection7                   },
  { IPFIX_TYPEID_mplsLabelStackSection8                  , IPFIX_BYTES_octetArray          ,     0, "mplsLabelStackSection8"                , IPFIX_DATA_TYPE_mplsLabelStackSection8                   },
  { IPFIX_TYPEID_mplsLabelStackSection9                  , IPFIX_BYTES_octetArray          ,     0, "mplsLabelStackSection9"                , IPFIX_DATA_TYPE_mplsLabelStackSection9                   },
  { IPFIX_TYPEID_mplsLabelStackSection10                 , IPFIX_BYTES_octetArray          ,     0, "mplsLabelStackSection10"               , IPFIX_DATA_TYPE_mplsLabelStackSection10                  },
  { IPFIX_TYPEID_destinationMacAddress                   , IPFIX_BYTES_macAddress          ,     0, "destinationMacAddress"                 , IPFIX_DATA_TYPE_destinationMacAddress                    },
  { IPFIX_TYPEID_postSourceMacAddress                    , IPFIX_BYTES_macAddress          ,     0, "postSourceMacAddress"                  , IPFIX_DATA_TYPE_postSourceMacAddress                     },
  { IPFIX_TYPEID_interfaceName                           , IPFIX_BYTES_string              ,     0, "interfaceName"                         , IPFIX_DATA_TYPE_interfaceName                            },
  { IPFIX_TYPEID_interfaceDescription                    , IPFIX_BYTES_string              ,     0, "interfaceDescription"                  , IPFIX_DATA_TYPE_interfaceDescription                     },
  { IPFIX_TYPEID_octetTotalCount                         , IPFIX_BYTES_unsigned64          ,     0, "octetTotalCount"                       , IPFIX_DATA_TYPE_octetTotalCount                          },
  { IPFIX_TYPEID_packetTotalCount                        , IPFIX_BYTES_unsigned64          ,     0, "packetTotalCount"                      , IPFIX_DATA_TYPE_packetTotalCount                         },
  { IPFIX_TYPEID_fragmentOffset                          , IPFIX_BYTES_unsigned16          ,     0, "fragmentOffset"                        , IPFIX_DATA_TYPE_fragmentOffset                           },
  { IPFIX_TYPEID_forwardingStatus                        , IPFIX_BYTES_unsigned32          ,     0, "forwardingStatus"                      , IPFIX_DATA_TYPE_forwardingStatus                         },
  { IPFIX_TYPEID_mplsVpnRouteDistinguisher               , IPFIX_BYTES_octetArray          ,     0, "mplsVpnRouteDistinguisher"             , IPFIX_DATA_TYPE_mplsVpnRouteDistinguisher                },
  { IPFIX_TYPEID_mplsTopLabelPrefixLength                , IPFIX_BYTES_unsigned8           ,     0, "mplsTopLabelPrefixLength"              , IPFIX_DATA_TYPE_mplsTopLabelPrefixLength                 },
  { IPFIX_TYPEID_srcTrafficIndex                         , IPFIX_BYTES_unsigned32          ,     0, "srcTrafficIndex"                       , IPFIX_DATA_TYPE_srcTrafficIndex                          },
  { IPFIX_TYPEID_dstTrafficIndex                         , IPFIX_BYTES_unsigned32          ,     0, "dstTrafficIndex"                       , IPFIX_DATA_TYPE_dstTrafficIndex                          },
  { IPFIX_TYPEID_applicationDescription                  , IPFIX_BYTES_string              ,     0, "applicationDescription"                , IPFIX_DATA_TYPE_applicationDescription                   },
  { IPFIX_TYPEID_applicationId                           , IPFIX_BYTES_octetArray          ,     0, "applicationId"                         , IPFIX_DATA_TYPE_applicationId                            },
  { IPFIX_TYPEID_applicationName                         , IPFIX_BYTES_string              ,     0, "applicationName"                       , IPFIX_DATA_TYPE_applicationName                          },
  { IPFIX_TYPEID_postIpDiffServCodePoint                 , IPFIX_BYTES_unsigned8           ,     0, "postIpDiffServCodePoint"               , IPFIX_DATA_TYPE_postIpDiffServCodePoint                  },
  { IPFIX_TYPEID_multicastReplicationFactor              , IPFIX_BYTES_unsigned32          ,     0, "multicastReplicationFactor"            , IPFIX_DATA_TYPE_multicastReplicationFactor               },
  { IPFIX_TYPEID_classificationEngineId                  , IPFIX_BYTES_unsigned8           ,     0, "classificationEngineId"                , IPFIX_DATA_TYPE_classificationEngineId                   },
  { IPFIX_TYPEID_bgpNextAdjacentAsNumber                 , IPFIX_BYTES_unsigned32          ,     0, "bgpNextAdjacentAsNumber"               , IPFIX_DATA_TYPE_bgpNextAdjacentAsNumber                  },
  { IPFIX_TYPEID_bgpPrevAdjacentAsNumber                 , IPFIX_BYTES_unsigned32          ,     0, "bgpPrevAdjacentAsNumber"               , IPFIX_DATA_TYPE_bgpPrevAdjacentAsNumber                  },
  { IPFIX_TYPEID_exporterIPv4Address                     , IPFIX_BYTES_ipv4Address         ,     0, "exporterIPv4Address"                   , IPFIX_DATA_TYPE_exporterIPv4Address                      },
  { IPFIX_TYPEID_exporterIPv6Address                     , IPFIX_BYTES_ipv6Address         ,     0, "exporterIPv6Address"                   , IPFIX_DATA_TYPE_exporterIPv6Address                      },
  { IPFIX_TYPEID_droppedOctetDeltaCount                  , IPFIX_BYTES_unsigned64          ,     0, "droppedOctetDeltaCount"                , IPFIX_DATA_TYPE_droppedOctetDeltaCount                   },
  { IPFIX_TYPEID_droppedPacketDeltaCount                 , IPFIX_BYTES_unsigned64          ,     0, "droppedPacketDeltaCount"               , IPFIX_DATA_TYPE_droppedPacketDeltaCount                  },
  { IPFIX_TYPEID_droppedOctetTotalCount                  , IPFIX_BYTES_unsigned64          ,     0, "droppedOctetTotalCount"                , IPFIX_DATA_TYPE_droppedOctetTotalCount                   },
  { IPFIX_TYPEID_droppedPacketTotalCount                 , IPFIX_BYTES_unsigned64          ,     0, "droppedPacketTotalCount"               , IPFIX_DATA_TYPE_droppedPacketTotalCount                  },
  { IPFIX_TYPEID_flowEndReason                           , IPFIX_BYTES_unsigned8           ,     0, "flowEndReason"                         , IPFIX_DATA_TYPE_flowEndReason                            },
  { IPFIX_TYPEID_commonPropertiesId                      , IPFIX_BYTES_unsigned64          ,     0, "commonPropertiesId"                    , IPFIX_DATA_TYPE_commonPropertiesId                       },
  { IPFIX_TYPEID_observationPointId                      , IPFIX_BYTES_unsigned64          ,     0, "observationPointId"                    , IPFIX_DATA_TYPE_observationPointId                       },
  { IPFIX_TYPEID_icmpTypeCodeIPv6                        , IPFIX_BYTES_unsigned16          ,     0, "icmpTypeCodeIPv6"                      , IPFIX_DATA_TYPE_icmpTypeCodeIPv6                         },
  { IPFIX_TYPEID_mplsTopLabelIPv6Address                 , IPFIX_BYTES_ipv6Address         ,     0, "mplsTopLabelIPv6Address"               , IPFIX_DATA_TYPE_mplsTopLabelIPv6Address                  },
  { IPFIX_TYPEID_lineCardId                              , IPFIX_BYTES_unsigned32          ,     0, "lineCardId"                            , IPFIX_DATA_TYPE_lineCardId                               },
  { IPFIX_TYPEID_portId                                  , IPFIX_BYTES_unsigned32          ,     0, "portId"                                , IPFIX_DATA_TYPE_portId                                   },
  { IPFIX_TYPEID_meteringProcessId                       , IPFIX_BYTES_unsigned32          ,     0, "meteringProcessId"                     , IPFIX_DATA_TYPE_meteringProcessId                        },
  { IPFIX_TYPEID_exportingProcessId                      , IPFIX_BYTES_unsigned32          ,     0, "exportingProcessId"                    , IPFIX_DATA_TYPE_exportingProcessId                       },
  { IPFIX_TYPEID_templateId                              , IPFIX_BYTES_unsigned16          ,     0, "templateId"                            , IPFIX_DATA_TYPE_templateId                               },
  { IPFIX_TYPEID_wlanChannelId                           , IPFIX_BYTES_unsigned8           ,     0, "wlanChannelId"                         , IPFIX_DATA_TYPE_wlanChannelId                            },
  { IPFIX_TYPEID_wlanSSID                                , IPFIX_BYTES_string              ,     0, "wlanSSID"                              , IPFIX_DATA_TYPE_wlanSSID                                 },
  { IPFIX_TYPEID_flowId                                  , IPFIX_BYTES_unsigned64          ,     0, "flowId"                                , IPFIX_DATA_TYPE_flowId                                   },
  { IPFIX_TYPEID_observationDomainId                     , IPFIX_BYTES_unsigned32          ,     0, "observationDomainId"                   , IPFIX_DATA_TYPE_observationDomainId                      },
  { IPFIX_TYPEID_flowStartSeconds                        , IPFIX_BYTES_dateTimeSeconds     ,     0, "flowStartSeconds"                      , IPFIX_DATA_TYPE_flowStartSeconds                         },
  { IPFIX_TYPEID_flowEndSeconds                          , IPFIX_BYTES_dateTimeSeconds     ,     0, "flowEndSeconds"                        , IPFIX_DATA_TYPE_flowEndSeconds                           },
  { IPFIX_TYPEID_flowStartMilliseconds                   , IPFIX_BYTES_dateTimeMilliseconds,     0, "flowStartMilliseconds"                 , IPFIX_DATA_TYPE_flowStartMilliseconds                    },
  { IPFIX_TYPEID_flowEndMilliseconds                     , IPFIX_BYTES_dateTimeMilliseconds,     0, "flowEndMilliseconds"                   , IPFIX_DATA_TYPE_flowEndMilliseconds                      },
  { IPFIX_TYPEID_flowStartMicroseconds                   , IPFIX_BYTES_dateTimeMicroseconds,     0, "flowStartMicroseconds"                 , IPFIX_DATA_TYPE_flowStartMicroseconds                    },
  { IPFIX_TYPEID_flowEndMicroseconds                     , IPFIX_BYTES_dateTimeMicroseconds,     0, "flowEndMicroseconds"                   , IPFIX_DATA_TYPE_flowEndMicroseconds                      },
  { IPFIX_TYPEID_flowStartNanoseconds                    , IPFIX_BYTES_dateTimeNanoseconds ,     0, "flowStartNanoseconds"                  , IPFIX_DATA_TYPE_flowStartNanoseconds                     },
  { IPFIX_TYPEID_flowEndNanoseconds                      , IPFIX_BYTES_dateTimeNanoseconds ,     0, "flowEndNanoseconds"                    , IPFIX_DATA_TYPE_flowEndNanoseconds                       },
  { IPFIX_TYPEID_flowStartDeltaMicroseconds              , IPFIX_BYTES_unsigned32          ,     0, "flowStartDeltaMicroseconds"            , IPFIX_DATA_TYPE_flowStartDeltaMicroseconds               },
  { IPFIX_TYPEID_flowEndDeltaMicroseconds                , IPFIX_BYTES_unsigned32          ,     0, "flowEndDeltaMicroseconds"              , IPFIX_DATA_TYPE_flowEndDeltaMicroseconds                 },
  { IPFIX_TYPEID_systemInitTimeMilliseconds              , IPFIX_BYTES_dateTimeMilliseconds,     0, "systemInitTimeMilliseconds"            , IPFIX_DATA_TYPE_systemInitTimeMilliseconds               },
  { IPFIX_TYPEID_flowDurationMilliseconds                , IPFIX_BYTES_unsigned32          ,     0, "flowDurationMilliseconds"              , IPFIX_DATA_TYPE_flowDurationMilliseconds                 },
  { IPFIX_TYPEID_flowDurationMicroseconds                , IPFIX_BYTES_unsigned32          ,     0, "flowDurationMicroseconds"              , IPFIX_DATA_TYPE_flowDurationMicroseconds                 },
  { IPFIX_TYPEID_observedFlowTotalCount                  , IPFIX_BYTES_unsigned64          ,     0, "observedFlowTotalCount"                , IPFIX_DATA_TYPE_observedFlowTotalCount                   },
  { IPFIX_TYPEID_ignoredPacketTotalCount                 , IPFIX_BYTES_unsigned64          ,     0, "ignoredPacketTotalCount"               , IPFIX_DATA_TYPE_ignoredPacketTotalCount                  },
  { IPFIX_TYPEID_ignoredOctetTotalCount                  , IPFIX_BYTES_unsigned64          ,     0, "ignoredOctetTotalCount"                , IPFIX_DATA_TYPE_ignoredOctetTotalCount                   },
  { IPFIX_TYPEID_notSentFlowTotalCount                   , IPFIX_BYTES_unsigned64          ,     0, "notSentFlowTotalCount"                 , IPFIX_DATA_TYPE_notSentFlowTotalCount                    },
  { IPFIX_TYPEID_notSentPacketTotalCount                 , IPFIX_BYTES_unsigned64          ,     0, "notSentPacketTotalCount"               , IPFIX_DATA_TYPE_notSentPacketTotalCount                  },
  { IPFIX_TYPEID_notSentOctetTotalCount                  , IPFIX_BYTES_unsigned64          ,     0, "notSentOctetTotalCount"                , IPFIX_DATA_TYPE_notSentOctetTotalCount                   },
  { IPFIX_TYPEID_destinationIPv6Prefix                   , IPFIX_BYTES_ipv6Address         ,     0, "destinationIPv6Prefix"                 , IPFIX_DATA_TYPE_destinationIPv6Prefix                    },
  { IPFIX_TYPEID_sourceIPv6Prefix                        , IPFIX_BYTES_ipv6Address         ,     0, "sourceIPv6Prefix"                      , IPFIX_DATA_TYPE_sourceIPv6Prefix                         },
  { IPFIX_TYPEID_postOctetTotalCount                     , IPFIX_BYTES_unsigned64          ,     0, "postOctetTotalCount"                   , IPFIX_DATA_TYPE_postOctetTotalCount                      },
  { IPFIX_TYPEID_postPacketTotalCount                    , IPFIX_BYTES_unsigned64          ,     0, "postPacketTotalCount"                  , IPFIX_DATA_TYPE_postPacketTotalCount                     },
  { IPFIX_TYPEID_flowKeyIndicator                        , IPFIX_BYTES_unsigned64          ,     0, "flowKeyIndicator"                      , IPFIX_DATA_TYPE_flowKeyIndicator                         },
  { IPFIX_TYPEID_postMCastPacketTotalCount               , IPFIX_BYTES_unsigned64          ,     0, "postMCastPacketTotalCount"             , IPFIX_DATA_TYPE_postMCastPacketTotalCount                },
  { IPFIX_TYPEID_postMCastOctetTotalCount                , IPFIX_BYTES_unsigned64          ,     0, "postMCastOctetTotalCount"              , IPFIX_DATA_TYPE_postMCastOctetTotalCount                 },
  { IPFIX_TYPEID_icmpTypeIPv4                            , IPFIX_BYTES_unsigned8           ,     0, "icmpTypeIPv4"                          , IPFIX_DATA_TYPE_icmpTypeIPv4                             },
  { IPFIX_TYPEID_icmpCodeIPv4                            , IPFIX_BYTES_unsigned8           ,     0, "icmpCodeIPv4"                          , IPFIX_DATA_TYPE_icmpCodeIPv4                             },
  { IPFIX_TYPEID_icmpTypeIPv6                            , IPFIX_BYTES_unsigned8           ,     0, "icmpTypeIPv6"                          , IPFIX_DATA_TYPE_icmpTypeIPv6                             },
  { IPFIX_TYPEID_icmpCodeIPv6                            , IPFIX_BYTES_unsigned8           ,     0, "icmpCodeIPv6"                          , IPFIX_DATA_TYPE_icmpCodeIPv6                             },
  { IPFIX_TYPEID_udpSourcePort                           , IPFIX_BYTES_unsigned16          ,     0, "udpSourcePort"                         , IPFIX_DATA_TYPE_udpSourcePort                            },
  { IPFIX_TYPEID_udpDestinationPort                      , IPFIX_BYTES_unsigned16          ,     0, "udpDestinationPort"                    , IPFIX_DATA_TYPE_udpDestinationPort                       },
  { IPFIX_TYPEID_tcpSourcePort                           , IPFIX_BYTES_unsigned16          ,     0, "tcpSourcePort"                         , IPFIX_DATA_TYPE_tcpSourcePort                            },
  { IPFIX_TYPEID_tcpDestinationPort                      , IPFIX_BYTES_unsigned16          ,     0, "tcpDestinationPort"                    , IPFIX_DATA_TYPE_tcpDestinationPort                       },
  { IPFIX_TYPEID_tcpSequenceNumber                       , IPFIX_BYTES_unsigned32          ,     0, "tcpSequenceNumber"                     , IPFIX_DATA_TYPE_tcpSequenceNumber                        },
  { IPFIX_TYPEID_tcpAcknowledgementNumber                , IPFIX_BYTES_unsigned32          ,     0, "tcpAcknowledgementNumber"              , IPFIX_DATA_TYPE_tcpAcknowledgementNumber                 },
  { IPFIX_TYPEID_tcpWindowSize                           , IPFIX_BYTES_unsigned16          ,     0, "tcpWindowSize"                         , IPFIX_DATA_TYPE_tcpWindowSize                            },
  { IPFIX_TYPEID_tcpUrgentPointer                        , IPFIX_BYTES_unsigned16          ,     0, "tcpUrgentPointer"                      , IPFIX_DATA_TYPE_tcpUrgentPointer                         },
  { IPFIX_TYPEID_tcpHeaderLength                         , IPFIX_BYTES_unsigned8           ,     0, "tcpHeaderLength"                       , IPFIX_DATA_TYPE_tcpHeaderLength                          },
  { IPFIX_TYPEID_ipHeaderLength                          , IPFIX_BYTES_unsigned8           ,     0, "ipHeaderLength"                        , IPFIX_DATA_TYPE_ipHeaderLength                           },
  { IPFIX_TYPEID_totalLengthIPv4                         , IPFIX_BYTES_unsigned16          ,     0, "totalLengthIPv4"                       , IPFIX_DATA_TYPE_totalLengthIPv4                          },
  { IPFIX_TYPEID_payloadLengthIPv6                       , IPFIX_BYTES_unsigned16          ,     0, "payloadLengthIPv6"                     , IPFIX_DATA_TYPE_payloadLengthIPv6                        },
  { IPFIX_TYPEID_ipTTL                                   , IPFIX_BYTES_unsigned8           ,     0, "ipTTL"                                 , IPFIX_DATA_TYPE_ipTTL                                    },
  { IPFIX_TYPEID_nextHeaderIPv6                          , IPFIX_BYTES_unsigned8           ,     0, "nextHeaderIPv6"                        , IPFIX_DATA_TYPE_nextHeaderIPv6                           },
  { IPFIX_TYPEID_mplsPayloadLength                       , IPFIX_BYTES_unsigned32          ,     0, "mplsPayloadLength"                     , IPFIX_DATA_TYPE_mplsPayloadLength                        },
  { IPFIX_TYPEID_ipDiffServCodePoint                     , IPFIX_BYTES_unsigned8           ,     0, "ipDiffServCodePoint"                   , IPFIX_DATA_TYPE_ipDiffServCodePoint                      },
  { IPFIX_TYPEID_ipPrecedence                            , IPFIX_BYTES_unsigned8           ,     0, "ipPrecedence"                          , IPFIX_DATA_TYPE_ipPrecedence                             },
  { IPFIX_TYPEID_fragmentFlags                           , IPFIX_BYTES_unsigned8           ,     0, "fragmentFlags"                         , IPFIX_DATA_TYPE_fragmentFlags                            },
  { IPFIX_TYPEID_octetDeltaSumOfSquares                  , IPFIX_BYTES_unsigned64          ,     0, "octetDeltaSumOfSquares"                , IPFIX_DATA_TYPE_octetDeltaSumOfSquares                   },
  { IPFIX_TYPEID_octetTotalSumOfSquares                  , IPFIX_BYTES_unsigned64          ,     0, "octetTotalSumOfSquares"                , IPFIX_DATA_TYPE_octetTotalSumOfSquares                   },
  { IPFIX_TYPEID_mplsTopLabelTTL                         , IPFIX_BYTES_unsigned8           ,     0, "mplsTopLabelTTL"                       , IPFIX_DATA_TYPE_mplsTopLabelTTL                          },
  { IPFIX_TYPEID_mplsLabelStackLength                    , IPFIX_BYTES_unsigned32          ,     0, "mplsLabelStackLength"                  , IPFIX_DATA_TYPE_mplsLabelStackLength                     },
  { IPFIX_TYPEID_mplsLabelStackDepth                     , IPFIX_BYTES_unsigned32          ,     0, "mplsLabelStackDepth"                   , IPFIX_DATA_TYPE_mplsLabelStackDepth                      },
  { IPFIX_TYPEID_mplsTopLabelExp                         , IPFIX_BYTES_unsigned8           ,     0, "mplsTopLabelExp"                       , IPFIX_DATA_TYPE_mplsTopLabelExp                          },
  { IPFIX_TYPEID_ipPayloadLength                         , IPFIX_BYTES_unsigned32          ,     0, "ipPayloadLength"                       , IPFIX_DATA_TYPE_ipPayloadLength                          },
  { IPFIX_TYPEID_udpMessageLength                        , IPFIX_BYTES_unsigned16          ,     0, "udpMessageLength"                      , IPFIX_DATA_TYPE_udpMessageLength                         },
  { IPFIX_TYPEID_isMulticast                             , IPFIX_BYTES_unsigned8           ,     0, "isMulticast"                           , IPFIX_DATA_TYPE_isMulticast                              },
  { IPFIX_TYPEID_ipv4IHL                                 , IPFIX_BYTES_unsigned8           ,     0, "ipv4IHL"                               , IPFIX_DATA_TYPE_ipv4IHL                                  },
  { IPFIX_TYPEID_ipv4Options                             , IPFIX_BYTES_unsigned32          ,     0, "ipv4Options"                           , IPFIX_DATA_TYPE_ipv4Options                              },
  { IPFIX_TYPEID_tcpOptions                              , IPFIX_BYTES_unsigned64          ,     0, "tcpOptions"                            , IPFIX_DATA_TYPE_tcpOptions                               },
  { IPFIX_TYPEID_paddingOctets                           , IPFIX_BYTES_octetArray          ,     0, "paddingOctets"                         , IPFIX_DATA_TYPE_paddingOctets                            },
  { IPFIX_TYPEID_collectorIPv4Address                    , IPFIX_BYTES_ipv4Address         ,     0, "collectorIPv4Address"                  , IPFIX_DATA_TYPE_collectorIPv4Address                     },
  { IPFIX_TYPEID_collectorIPv6Address                    , IPFIX_BYTES_ipv6Address         ,     0, "collectorIPv6Address"                  , IPFIX_DATA_TYPE_collectorIPv6Address                     },
  { IPFIX_TYPEID_exportInterface                         , IPFIX_BYTES_unsigned32          ,     0, "exportInterface"                       , IPFIX_DATA_TYPE_exportInterface                          },
  { IPFIX_TYPEID_exportProtocolVersion                   , IPFIX_BYTES_unsigned8           ,     0, "exportProtocolVersion"                 , IPFIX_DATA_TYPE_exportProtocolVersion                    },
  { IPFIX_TYPEID_exportTransportProtocol                 , IPFIX_BYTES_unsigned8           ,     0, "exportTransportProtocol"               , IPFIX_DATA_TYPE_exportTransportProtocol                  },
  { IPFIX_TYPEID_collectorTransportPort                  , IPFIX_BYTES_unsigned16          ,     0, "collectorTransportPort"                , IPFIX_DATA_TYPE_collectorTransportPort                   },
  { IPFIX_TYPEID_exporterTransportPort                   , IPFIX_BYTES_unsigned16          ,     0, "exporterTransportPort"                 , IPFIX_DATA_TYPE_exporterTransportPort                    },
  { IPFIX_TYPEID_tcpSynTotalCount                        , IPFIX_BYTES_unsigned64          ,     0, "tcpSynTotalCount"                      , IPFIX_DATA_TYPE_tcpSynTotalCount                         },
  { IPFIX_TYPEID_tcpFinTotalCount                        , IPFIX_BYTES_unsigned64          ,     0, "tcpFinTotalCount"                      , IPFIX_DATA_TYPE_tcpFinTotalCount                         },
  { IPFIX_TYPEID_tcpRstTotalCount                        , IPFIX_BYTES_unsigned64          ,     0, "tcpRstTotalCount"                      , IPFIX_DATA_TYPE_tcpRstTotalCount                         },
  { IPFIX_TYPEID_tcpPshTotalCount                        , IPFIX_BYTES_unsigned64          ,     0, "tcpPshTotalCount"                      , IPFIX_DATA_TYPE_tcpPshTotalCount                         },
  { IPFIX_TYPEID_tcpAckTotalCount                        , IPFIX_BYTES_unsigned64          ,     0, "tcpAckTotalCount"                      , IPFIX_DATA_TYPE_tcpAckTotalCount                         },
  { IPFIX_TYPEID_tcpUrgTotalCount                        , IPFIX_BYTES_unsigned64          ,     0, "tcpUrgTotalCount"                      , IPFIX_DATA_TYPE_tcpUrgTotalCount                         },
  { IPFIX_TYPEID_ipTotalLength                           , IPFIX_BYTES_unsigned64          ,     0, "ipTotalLength"                         , IPFIX_DATA_TYPE_ipTotalLength                            },
  { IPFIX_TYPEID_postNATSourceIPv4Address                , IPFIX_BYTES_ipv4Address         ,     0, "postNATSourceIPv4Address"              , IPFIX_DATA_TYPE_postNATSourceIPv4Address                 },
  { IPFIX_TYPEID_postNATDestinationIPv4Address           , IPFIX_BYTES_ipv4Address         ,     0, "postNATDestinationIPv4Address"         , IPFIX_DATA_TYPE_postNATDestinationIPv4Address            },
  { IPFIX_TYPEID_postNAPTSourceTransportPort             , IPFIX_BYTES_unsigned16          ,     0, "postNAPTSourceTransportPort"           , IPFIX_DATA_TYPE_postNAPTSourceTransportPort              },
  { IPFIX_TYPEID_postNAPTDestinationTransportPort        , IPFIX_BYTES_unsigned16          ,     0, "postNAPTDestinationTransportPort"      , IPFIX_DATA_TYPE_postNAPTDestinationTransportPort         },
  { IPFIX_TYPEID_natOriginatingAddressRealm              , IPFIX_BYTES_unsigned8           ,     0, "natOriginatingAddressRealm"            , IPFIX_DATA_TYPE_natOriginatingAddressRealm               },
  { IPFIX_TYPEID_natEvent                                , IPFIX_BYTES_unsigned8           ,     0, "natEvent"                              , IPFIX_DATA_TYPE_natEvent                                 },
  { IPFIX_TYPEID_initiatorOctets                         , IPFIX_BYTES_unsigned64          ,     0, "initiatorOctets"                       , IPFIX_DATA_TYPE_initiatorOctets                          },
  { IPFIX_TYPEID_responderOctets                         , IPFIX_BYTES_unsigned64          ,     0, "responderOctets"                       , IPFIX_DATA_TYPE_responderOctets                          },
  { IPFIX_TYPEID_firewallEvent                           , IPFIX_BYTES_unsigned8           ,     0, "firewallEvent"                         , IPFIX_DATA_TYPE_firewallEvent                            },
  { IPFIX_TYPEID_ingressVRFID                            , IPFIX_BYTES_unsigned32          ,     0, "ingressVRFID"                          , IPFIX_DATA_TYPE_ingressVRFID                             },
  { IPFIX_TYPEID_egressVRFID                             , IPFIX_BYTES_unsigned32          ,     0, "egressVRFID"                           , IPFIX_DATA_TYPE_egressVRFID                              },
  { IPFIX_TYPEID_VRFname                                 , IPFIX_BYTES_string              ,     0, "VRFname"                               , IPFIX_DATA_TYPE_VRFname                                  },
  { IPFIX_TYPEID_postMplsTopLabelExp                     , IPFIX_BYTES_unsigned8           ,     0, "postMplsTopLabelExp"                   , IPFIX_DATA_TYPE_postMplsTopLabelExp                      },
  { IPFIX_TYPEID_tcpWindowScale                          , IPFIX_BYTES_unsigned16          ,     0, "tcpWindowScale"                        , IPFIX_DATA_TYPE_tcpWindowScale                           },
  { IPFIX_TYPEID_biflowDirection                         , IPFIX_BYTES_unsigned8           ,     0, "biflowDirection"                       , IPFIX_DATA_TYPE_biflowDirection                          },
  { IPFIX_TYPEID_ethernetHeaderLength                    , IPFIX_BYTES_unsigned8           ,     0, "ethernetHeaderLength"                  , IPFIX_DATA_TYPE_ethernetHeaderLength                     },
  { IPFIX_TYPEID_ethernetPayloadLength                   , IPFIX_BYTES_unsigned16          ,     0, "ethernetPayloadLength"                 , IPFIX_DATA_TYPE_ethernetPayloadLength                    },
  { IPFIX_TYPEID_ethernetTotalLength                     , IPFIX_BYTES_unsigned16          ,     0, "ethernetTotalLength"                   , IPFIX_DATA_TYPE_ethernetTotalLength                      },
  { IPFIX_TYPEID_dot1qVlanId                             , IPFIX_BYTES_unsigned16          ,     0, "dot1qVlanId"                           , IPFIX_DATA_TYPE_dot1qVlanId                              },
  { IPFIX_TYPEID_dot1qPriority                           , IPFIX_BYTES_unsigned8           ,     0, "dot1qPriority"                         , IPFIX_DATA_TYPE_dot1qPriority                            },
  { IPFIX_TYPEID_dot1qCustomerVlanId                     , IPFIX_BYTES_unsigned16          ,     0, "dot1qCustomerVlanId"                   , IPFIX_DATA_TYPE_dot1qCustomerVlanId                      },
  { IPFIX_TYPEID_dot1qCustomerPriority                   , IPFIX_BYTES_unsigned8           ,     0, "dot1qCustomerPriority"                 , IPFIX_DATA_TYPE_dot1qCustomerPriority                    },
  { IPFIX_TYPEID_metroEvcId                              , IPFIX_BYTES_string              ,     0, "metroEvcId"                            , IPFIX_DATA_TYPE_metroEvcId                               },
  { IPFIX_TYPEID_metroEvcType                            , IPFIX_BYTES_unsigned8           ,     0, "metroEvcType"                          , IPFIX_DATA_TYPE_metroEvcType                             },
  { IPFIX_TYPEID_pseudoWireId                            , IPFIX_BYTES_unsigned32          ,     0, "pseudoWireId"                          , IPFIX_DATA_TYPE_pseudoWireId                             },
  { IPFIX_TYPEID_pseudoWireType                          , IPFIX_BYTES_unsigned16          ,     0, "pseudoWireType"                        , IPFIX_DATA_TYPE_pseudoWireType                           },
  { IPFIX_TYPEID_pseudoWireControlWord                   , IPFIX_BYTES_unsigned32          ,     0, "pseudoWireControlWord"                 , IPFIX_DATA_TYPE_pseudoWireControlWord                    },
  { IPFIX_TYPEID_ingressPhysicalInterface                , IPFIX_BYTES_unsigned32          ,     0, "ingressPhysicalInterface"              , IPFIX_DATA_TYPE_ingressPhysicalInterface                 },
  { IPFIX_TYPEID_egressPhysicalInterface                 , IPFIX_BYTES_unsigned32          ,     0, "egressPhysicalInterface"               , IPFIX_DATA_TYPE_egressPhysicalInterface                  },
  { IPFIX_TYPEID_postDot1qVlanId                         , IPFIX_BYTES_unsigned16          ,     0, "postDot1qVlanId"                       , IPFIX_DATA_TYPE_postDot1qVlanId                          },
  { IPFIX_TYPEID_postDot1qCustomerVlanId                 , IPFIX_BYTES_unsigned16          ,     0, "postDot1qCustomerVlanId"               , IPFIX_DATA_TYPE_postDot1qCustomerVlanId                  },
  { IPFIX_TYPEID_ethernetType                            , IPFIX_BYTES_unsigned16          ,     0, "ethernetType"                          , IPFIX_DATA_TYPE_ethernetType                             },
  { IPFIX_TYPEID_postIpPrecedence                        , IPFIX_BYTES_unsigned8           ,     0, "postIpPrecedence"                      , IPFIX_DATA_TYPE_postIpPrecedence                         },
  { IPFIX_TYPEID_collectionTimeMilliseconds              , IPFIX_BYTES_dateTimeMilliseconds,     0, "collectionTimeMilliseconds"            , IPFIX_DATA_TYPE_collectionTimeMilliseconds               },
  { IPFIX_TYPEID_exportSctpStreamId                      , IPFIX_BYTES_unsigned16          ,     0, "exportSctpStreamId"                    , IPFIX_DATA_TYPE_exportSctpStreamId                       },
  { IPFIX_TYPEID_maxExportSeconds                        , IPFIX_BYTES_dateTimeSeconds     ,     0, "maxExportSeconds"                      , IPFIX_DATA_TYPE_maxExportSeconds                         },
  { IPFIX_TYPEID_maxFlowEndSeconds                       , IPFIX_BYTES_dateTimeSeconds     ,     0, "maxFlowEndSeconds"                     , IPFIX_DATA_TYPE_maxFlowEndSeconds                        },
  { IPFIX_TYPEID_messageMD5Checksum                      , IPFIX_BYTES_octetArray          ,     0, "messageMD5Checksum"                    , IPFIX_DATA_TYPE_messageMD5Checksum                       },
  { IPFIX_TYPEID_messageScope                            , IPFIX_BYTES_unsigned8           ,     0, "messageScope"                          , IPFIX_DATA_TYPE_messageScope                             },
  { IPFIX_TYPEID_minExportSeconds                        , IPFIX_BYTES_dateTimeSeconds     ,     0, "minExportSeconds"                      , IPFIX_DATA_TYPE_minExportSeconds                         },
  { IPFIX_TYPEID_minFlowStartSeconds                     , IPFIX_BYTES_dateTimeSeconds     ,     0, "minFlowStartSeconds"                   , IPFIX_DATA_TYPE_minFlowStartSeconds                      },
  { IPFIX_TYPEID_opaqueOctets                            , IPFIX_BYTES_octetArray          ,     0, "opaqueOctets"                          , IPFIX_DATA_TYPE_opaqueOctets                             },
  { IPFIX_TYPEID_sessionScope                            , IPFIX_BYTES_unsigned8           ,     0, "sessionScope"                          , IPFIX_DATA_TYPE_sessionScope                             },
  { IPFIX_TYPEID_maxFlowEndMicroseconds                  , IPFIX_BYTES_dateTimeMicroseconds,     0, "maxFlowEndMicroseconds"                , IPFIX_DATA_TYPE_maxFlowEndMicroseconds                   },
  { IPFIX_TYPEID_maxFlowEndMilliseconds                  , IPFIX_BYTES_dateTimeMilliseconds,     0, "maxFlowEndMilliseconds"                , IPFIX_DATA_TYPE_maxFlowEndMilliseconds                   },
  { IPFIX_TYPEID_maxFlowEndNanoseconds                   , IPFIX_BYTES_dateTimeNanoseconds ,     0, "maxFlowEndNanoseconds"                 , IPFIX_DATA_TYPE_maxFlowEndNanoseconds                    },
  { IPFIX_TYPEID_minFlowStartMicroseconds                , IPFIX_BYTES_dateTimeMicroseconds,     0, "minFlowStartMicroseconds"              , IPFIX_DATA_TYPE_minFlowStartMicroseconds                 },
  { IPFIX_TYPEID_minFlowStartMilliseconds                , IPFIX_BYTES_dateTimeMilliseconds,     0, "minFlowStartMilliseconds"              , IPFIX_DATA_TYPE_minFlowStartMilliseconds                 },
  { IPFIX_TYPEID_minFlowStartNanoseconds                 , IPFIX_BYTES_dateTimeNanoseconds ,     0, "minFlowStartNanoseconds"               , IPFIX_DATA_TYPE_minFlowStartNanoseconds                  },
  { IPFIX_TYPEID_collectorCertificate                    , IPFIX_BYTES_octetArray          ,     0, "collectorCertificate"                  , IPFIX_DATA_TYPE_collectorCertificate                     },
  { IPFIX_TYPEID_exporterCertificate                     , IPFIX_BYTES_octetArray          ,     0, "exporterCertificate"                   , IPFIX_DATA_TYPE_exporterCertificate                      },
  { IPFIX_TYPEID_dataRecordsReliability                  , IPFIX_BYTES_boolean             ,     0, "dataRecordsReliability"                , IPFIX_DATA_TYPE_dataRecordsReliability                   },
  { IPFIX_TYPEID_observationPointType                    , IPFIX_BYTES_unsigned8           ,     0, "observationPointType"                  , IPFIX_DATA_TYPE_observationPointType                     },
  { IPFIX_TYPEID_newConnectionDeltaCount                 , IPFIX_BYTES_unsigned32          ,     0, "newConnectionDeltaCount"               , IPFIX_DATA_TYPE_newConnectionDeltaCount                  },
  { IPFIX_TYPEID_connectionSumDurationSeconds            , IPFIX_BYTES_unsigned64          ,     0, "connectionSumDurationSeconds"          , IPFIX_DATA_TYPE_connectionSumDurationSeconds             },
  { IPFIX_TYPEID_connectionTransactionId                 , IPFIX_BYTES_unsigned64          ,     0, "connectionTransactionId"               , IPFIX_DATA_TYPE_connectionTransactionId                  },
  { IPFIX_TYPEID_postNATSourceIPv6Address                , IPFIX_BYTES_ipv6Address         ,     0, "postNATSourceIPv6Address"              , IPFIX_DATA_TYPE_postNATSourceIPv6Address                 },
  { IPFIX_TYPEID_postNATDestinationIPv6Address           , IPFIX_BYTES_ipv6Address         ,     0, "postNATDestinationIPv6Address"         , IPFIX_DATA_TYPE_postNATDestinationIPv6Address            },
  { IPFIX_TYPEID_natPoolId                               , IPFIX_BYTES_unsigned32          ,     0, "natPoolId"                             , IPFIX_DATA_TYPE_natPoolId                                },
  { IPFIX_TYPEID_natPoolName                             , IPFIX_BYTES_string              ,     0, "natPoolName"                           , IPFIX_DATA_TYPE_natPoolName                              },
  { IPFIX_TYPEID_anonymizationFlags                      , IPFIX_BYTES_unsigned16          ,     0, "anonymizationFlags"                    , IPFIX_DATA_TYPE_anonymizationFlags                       },
  { IPFIX_TYPEID_anonymizationTechnique                  , IPFIX_BYTES_unsigned16          ,     0, "anonymizationTechnique"                , IPFIX_DATA_TYPE_anonymizationTechnique                   },
  { IPFIX_TYPEID_informationElementIndex                 , IPFIX_BYTES_unsigned16          ,     0, "informationElementIndex"               , IPFIX_DATA_TYPE_informationElementIndex                  },
  { IPFIX_TYPEID_p2pTechnology                           , IPFIX_BYTES_string              ,     0, "p2pTechnology"                         , IPFIX_DATA_TYPE_p2pTechnology                            },
  { IPFIX_TYPEID_tunnelTechnology                        , IPFIX_BYTES_string              ,     0, "tunnelTechnology"                      , IPFIX_DATA_TYPE_tunnelTechnology                         },
  { IPFIX_TYPEID_encryptedTechnology                     , IPFIX_BYTES_string              ,     0, "encryptedTechnology"                   , IPFIX_DATA_TYPE_encryptedTechnology                      },
  { IPFIX_TYPEID_basicList                               , IPFIX_BYTES_basicList           ,     0, "basicList"                             , IPFIX_DATA_TYPE_basicList                                },
  { IPFIX_TYPEID_subTemplateList                         , IPFIX_BYTES_subTemplateList     ,     0, "subTemplateList"                       , IPFIX_DATA_TYPE_subTemplateList                          },
  { IPFIX_TYPEID_subTemplateMultiList                    , IPFIX_BYTES_subTemplateMultiList,     0, "subTemplateMultiList"                  , IPFIX_DATA_TYPE_subTemplateMultiList                     },
  { IPFIX_TYPEID_bgpValidityState                        , IPFIX_BYTES_unsigned8           ,     0, "bgpValidityState"                      , IPFIX_DATA_TYPE_bgpValidityState                         },
  { IPFIX_TYPEID_IPSecSPI                                , IPFIX_BYTES_unsigned32          ,     0, "IPSecSPI"                              , IPFIX_DATA_TYPE_IPSecSPI                                 },
  { IPFIX_TYPEID_greKey                                  , IPFIX_BYTES_unsigned32          ,     0, "greKey"                                , IPFIX_DATA_TYPE_greKey                                   },
  { IPFIX_TYPEID_natType                                 , IPFIX_BYTES_unsigned8           ,     0, "natType"                               , IPFIX_DATA_TYPE_natType                                  },
  { IPFIX_TYPEID_initiatorPackets                        , IPFIX_BYTES_unsigned64          ,     0, "initiatorPackets"                      , IPFIX_DATA_TYPE_initiatorPackets                         },
  { IPFIX_TYPEID_responderPackets                        , IPFIX_BYTES_unsigned64          ,     0, "responderPackets"                      , IPFIX_DATA_TYPE_responderPackets                         },
  { IPFIX_TYPEID_observationDomainName                   , IPFIX_BYTES_string              ,     0, "observationDomainName"                 , IPFIX_DATA_TYPE_observationDomainName                    },
  { IPFIX_TYPEID_selectionSequenceId                     , IPFIX_BYTES_unsigned64          ,     0, "selectionSequenceId"                   , IPFIX_DATA_TYPE_selectionSequenceId                      },
  { IPFIX_TYPEID_selectorId                              , IPFIX_BYTES_unsigned64          ,     0, "selectorId"                            , IPFIX_DATA_TYPE_selectorId                               },
  { IPFIX_TYPEID_informationElementId                    , IPFIX_BYTES_unsigned16          ,     0, "informationElementId"                  , IPFIX_DATA_TYPE_informationElementId                     },
  { IPFIX_TYPEID_selectorAlgorithm                       , IPFIX_BYTES_unsigned16          ,     0, "selectorAlgorithm"                     , IPFIX_DATA_TYPE_selectorAlgorithm                        },
  { IPFIX_TYPEID_samplingPacketInterval                  , IPFIX_BYTES_unsigned32          ,     0, "samplingPacketInterval"                , IPFIX_DATA_TYPE_samplingPacketInterval                   },
  { IPFIX_TYPEID_samplingPacketSpace                     , IPFIX_BYTES_unsigned32          ,     0, "samplingPacketSpace"                   , IPFIX_DATA_TYPE_samplingPacketSpace                      },
  { IPFIX_TYPEID_samplingTimeInterval                    , IPFIX_BYTES_unsigned32          ,     0, "samplingTimeInterval"                  , IPFIX_DATA_TYPE_samplingTimeInterval                     },
  { IPFIX_TYPEID_samplingTimeSpace                       , IPFIX_BYTES_unsigned32          ,     0, "samplingTimeSpace"                     , IPFIX_DATA_TYPE_samplingTimeSpace                        },
  { IPFIX_TYPEID_samplingSize                            , IPFIX_BYTES_unsigned32          ,     0, "samplingSize"                          , IPFIX_DATA_TYPE_samplingSize                             },
  { IPFIX_TYPEID_samplingPopulation                      , IPFIX_BYTES_unsigned32          ,     0, "samplingPopulation"                    , IPFIX_DATA_TYPE_samplingPopulation                       },
  { IPFIX_TYPEID_samplingProbability                     , IPFIX_BYTES_float64             ,     0, "samplingProbability"                   , IPFIX_DATA_TYPE_samplingProbability                      },
  { IPFIX_TYPEID_dataLinkFrameSize                       , IPFIX_BYTES_unsigned16          ,     0, "dataLinkFrameSize"                     , IPFIX_DATA_TYPE_dataLinkFrameSize                        },
  { IPFIX_TYPEID_ipHeaderPacketSection                   , IPFIX_BYTES_octetArray          ,     0, "ipHeaderPacketSection"                 , IPFIX_DATA_TYPE_ipHeaderPacketSection                    },
  { IPFIX_TYPEID_ipPayloadPacketSection                  , IPFIX_BYTES_octetArray          ,     0, "ipPayloadPacketSection"                , IPFIX_DATA_TYPE_ipPayloadPacketSection                   },
  { IPFIX_TYPEID_dataLinkFrameSection                    , IPFIX_BYTES_octetArray          ,     0, "dataLinkFrameSection"                  , IPFIX_DATA_TYPE_dataLinkFrameSection                     },
  { IPFIX_TYPEID_mplsLabelStackSection                   , IPFIX_BYTES_octetArray          ,     0, "mplsLabelStackSection"                 , IPFIX_DATA_TYPE_mplsLabelStackSection                    },
  { IPFIX_TYPEID_mplsPayloadPacketSection                , IPFIX_BYTES_octetArray          ,     0, "mplsPayloadPacketSection"              , IPFIX_DATA_TYPE_mplsPayloadPacketSection                 },
  { IPFIX_TYPEID_selectorIdTotalPktsObserved             , IPFIX_BYTES_unsigned64          ,     0, "selectorIdTotalPktsObserved"           , IPFIX_DATA_TYPE_selectorIdTotalPktsObserved              },
  { IPFIX_TYPEID_selectorIdTotalPktsSelected             , IPFIX_BYTES_unsigned64          ,     0, "selectorIdTotalPktsSelected"           , IPFIX_DATA_TYPE_selectorIdTotalPktsSelected              },
  { IPFIX_TYPEID_absoluteError                           , IPFIX_BYTES_float64             ,     0, "absoluteError"                         , IPFIX_DATA_TYPE_absoluteError                            },
  { IPFIX_TYPEID_relativeError                           , IPFIX_BYTES_float64             ,     0, "relativeError"                         , IPFIX_DATA_TYPE_relativeError                            },
  { IPFIX_TYPEID_observationTimeSeconds                  , IPFIX_BYTES_dateTimeSeconds     ,     0, "observationTimeSeconds"                , IPFIX_DATA_TYPE_observationTimeSeconds                   },
  { IPFIX_TYPEID_observationTimeMilliseconds             , IPFIX_BYTES_dateTimeMilliseconds,     0, "observationTimeMilliseconds"           , IPFIX_DATA_TYPE_observationTimeMilliseconds              },
  { IPFIX_TYPEID_observationTimeMicroseconds             , IPFIX_BYTES_dateTimeMicroseconds,     0, "observationTimeMicroseconds"           , IPFIX_DATA_TYPE_observationTimeMicroseconds              },
  { IPFIX_TYPEID_observationTimeNanoseconds              , IPFIX_BYTES_dateTimeNanoseconds ,     0, "observationTimeNanoseconds"            , IPFIX_DATA_TYPE_observationTimeNanoseconds               },
  { IPFIX_TYPEID_digestHashValue                         , IPFIX_BYTES_unsigned64          ,     0, "digestHashValue"                       , IPFIX_DATA_TYPE_digestHashValue                          },
  { IPFIX_TYPEID_hashIPPayloadOffset                     , IPFIX_BYTES_unsigned64          ,     0, "hashIPPayloadOffset"                   , IPFIX_DATA_TYPE_hashIPPayloadOffset                      },
  { IPFIX_TYPEID_hashIPPayloadSize                       , IPFIX_BYTES_unsigned64          ,     0, "hashIPPayloadSize"                     , IPFIX_DATA_TYPE_hashIPPayloadSize                        },
  { IPFIX_TYPEID_hashOutputRangeMin                      , IPFIX_BYTES_unsigned64          ,     0, "hashOutputRangeMin"                    , IPFIX_DATA_TYPE_hashOutputRangeMin                       },
  { IPFIX_TYPEID_hashOutputRangeMax                      , IPFIX_BYTES_unsigned64          ,     0, "hashOutputRangeMax"                    , IPFIX_DATA_TYPE_hashOutputRangeMax                       },
  { IPFIX_TYPEID_hashSelectedRangeMin                    , IPFIX_BYTES_unsigned64          ,     0, "hashSelectedRangeMin"                  , IPFIX_DATA_TYPE_hashSelectedRangeMin                     },
  { IPFIX_TYPEID_hashSelectedRangeMax                    , IPFIX_BYTES_unsigned64          ,     0, "hashSelectedRangeMax"                  , IPFIX_DATA_TYPE_hashSelectedRangeMax                     },
  { IPFIX_TYPEID_hashDigestOutput                        , IPFIX_BYTES_boolean             ,     0, "hashDigestOutput"                      , IPFIX_DATA_TYPE_hashDigestOutput                         },
  { IPFIX_TYPEID_hashInitialiserValue                    , IPFIX_BYTES_unsigned64          ,     0, "hashInitialiserValue"                  , IPFIX_DATA_TYPE_hashInitialiserValue                     },
  { IPFIX_TYPEID_selectorName                            , IPFIX_BYTES_string              ,     0, "selectorName"                          , IPFIX_DATA_TYPE_selectorName                             },
  { IPFIX_TYPEID_upperCILimit                            , IPFIX_BYTES_float64             ,     0, "upperCILimit"                          , IPFIX_DATA_TYPE_upperCILimit                             },
  { IPFIX_TYPEID_lowerCILimit                            , IPFIX_BYTES_float64             ,     0, "lowerCILimit"                          , IPFIX_DATA_TYPE_lowerCILimit                             },
  { IPFIX_TYPEID_confidenceLevel                         , IPFIX_BYTES_float64             ,     0, "confidenceLevel"                       , IPFIX_DATA_TYPE_confidenceLevel                          },
  { IPFIX_TYPEID_informationElementDataType              , IPFIX_BYTES_unsigned8           ,     0, "informationElementDataType"            , IPFIX_DATA_TYPE_informationElementDataType               },
  { IPFIX_TYPEID_informationElementDescription           , IPFIX_BYTES_string              ,     0, "informationElementDescription"         , IPFIX_DATA_TYPE_informationElementDescription            },
  { IPFIX_TYPEID_informationElementName                  , IPFIX_BYTES_string              ,     0, "informationElementName"                , IPFIX_DATA_TYPE_informationElementName                   },
  { IPFIX_TYPEID_informationElementRangeBegin            , IPFIX_BYTES_unsigned64          ,     0, "informationElementRangeBegin"          , IPFIX_DATA_TYPE_informationElementRangeBegin             },
  { IPFIX_TYPEID_informationElementRangeEnd              , IPFIX_BYTES_unsigned64          ,     0, "informationElementRangeEnd"            , IPFIX_DATA_TYPE_informationElementRangeEnd               },
  { IPFIX_TYPEID_informationElementSemantics             , IPFIX_BYTES_unsigned8           ,     0, "informationElementSemantics"           , IPFIX_DATA_TYPE_informationElementSemantics              },
  { IPFIX_TYPEID_informationElementUnits                 , IPFIX_BYTES_unsigned16          ,     0, "informationElementUnits"               , IPFIX_DATA_TYPE_informationElementUnits                  },
  { IPFIX_TYPEID_privateEnterpriseNumber                 , IPFIX_BYTES_unsigned32          ,     0, "privateEnterpriseNumber"               , IPFIX_DATA_TYPE_privateEnterpriseNumber                  },
  { IPFIX_TYPEID_virtualStationInterfaceId               , IPFIX_BYTES_octetArray          ,     0, "virtualStationInterfaceId"             , IPFIX_DATA_TYPE_virtualStationInterfaceId                },
  { IPFIX_TYPEID_virtualStationInterfaceName             , IPFIX_BYTES_string              ,     0, "virtualStationInterfaceName"           , IPFIX_DATA_TYPE_virtualStationInterfaceName              },
  { IPFIX_TYPEID_virtualStationUUID                      , IPFIX_BYTES_octetArray          ,     0, "virtualStationUUID"                    , IPFIX_DATA_TYPE_virtualStationUUID                       },
  { IPFIX_TYPEID_virtualStationName                      , IPFIX_BYTES_string              ,     0, "virtualStationName"                    , IPFIX_DATA_TYPE_virtualStationName                       },
  { IPFIX_TYPEID_layer2SegmentId                         , IPFIX_BYTES_unsigned64          ,     0, "layer2SegmentId"                       , IPFIX_DATA_TYPE_layer2SegmentId                          },
  { IPFIX_TYPEID_layer2OctetDeltaCount                   , IPFIX_BYTES_unsigned64          ,     0, "layer2OctetDeltaCount"                 , IPFIX_DATA_TYPE_layer2OctetDeltaCount                    },
  { IPFIX_TYPEID_layer2OctetTotalCount                   , IPFIX_BYTES_unsigned64          ,     0, "layer2OctetTotalCount"                 , IPFIX_DATA_TYPE_layer2OctetTotalCount                    },
  { IPFIX_TYPEID_ingressUnicastPacketTotalCount          , IPFIX_BYTES_unsigned64          ,     0, "ingressUnicastPacketTotalCount"        , IPFIX_DATA_TYPE_ingressUnicastPacketTotalCount           },
  { IPFIX_TYPEID_ingressMulticastPacketTotalCount        , IPFIX_BYTES_unsigned64          ,     0, "ingressMulticastPacketTotalCount"      , IPFIX_DATA_TYPE_ingressMulticastPacketTotalCount         },
  { IPFIX_TYPEID_ingressBroadcastPacketTotalCount        , IPFIX_BYTES_unsigned64          ,     0, "ingressBroadcastPacketTotalCount"      , IPFIX_DATA_TYPE_ingressBroadcastPacketTotalCount         },
  { IPFIX_TYPEID_egressUnicastPacketTotalCount           , IPFIX_BYTES_unsigned64          ,     0, "egressUnicastPacketTotalCount"         , IPFIX_DATA_TYPE_egressUnicastPacketTotalCount            },
  { IPFIX_TYPEID_egressBroadcastPacketTotalCount         , IPFIX_BYTES_unsigned64          ,     0, "egressBroadcastPacketTotalCount"       , IPFIX_DATA_TYPE_egressBroadcastPacketTotalCount          },
  { IPFIX_TYPEID_monitoringIntervalStartMilliSeconds     , IPFIX_BYTES_dateTimeMilliseconds,     0, "monitoringIntervalStartMilliSeconds"   , IPFIX_DATA_TYPE_monitoringIntervalStartMilliSeconds      },
  { IPFIX_TYPEID_monitoringIntervalEndMilliSeconds       , IPFIX_BYTES_dateTimeMilliseconds,     0, "monitoringIntervalEndMilliSeconds"     , IPFIX_DATA_TYPE_monitoringIntervalEndMilliSeconds        },
  { IPFIX_TYPEID_portRangeStart                          , IPFIX_BYTES_unsigned16          ,     0, "portRangeStart"                        , IPFIX_DATA_TYPE_portRangeStart                           },
  { IPFIX_TYPEID_portRangeEnd                            , IPFIX_BYTES_unsigned16          ,     0, "portRangeEnd"                          , IPFIX_DATA_TYPE_portRangeEnd                             },
  { IPFIX_TYPEID_portRangeStepSize                       , IPFIX_BYTES_unsigned16          ,     0, "portRangeStepSize"                     , IPFIX_DATA_TYPE_portRangeStepSize                        },
  { IPFIX_TYPEID_portRangeNumPorts                       , IPFIX_BYTES_unsigned16          ,     0, "portRangeNumPorts"                     , IPFIX_DATA_TYPE_portRangeNumPorts                        },
  { IPFIX_TYPEID_staMacAddress                           , IPFIX_BYTES_macAddress          ,     0, "staMacAddress"                         , IPFIX_DATA_TYPE_staMacAddress                            },
  { IPFIX_TYPEID_staIPv4Address                          , IPFIX_BYTES_ipv4Address         ,     0, "staIPv4Address"                        , IPFIX_DATA_TYPE_staIPv4Address                           },
  { IPFIX_TYPEID_wtpMacAddress                           , IPFIX_BYTES_macAddress          ,     0, "wtpMacAddress"                         , IPFIX_DATA_TYPE_wtpMacAddress                            },
  { IPFIX_TYPEID_ingressInterfaceType                    , IPFIX_BYTES_unsigned32          ,     0, "ingressInterfaceType"                  , IPFIX_DATA_TYPE_ingressInterfaceType                     },
  { IPFIX_TYPEID_egressInterfaceType                     , IPFIX_BYTES_unsigned32          ,     0, "egressInterfaceType"                   , IPFIX_DATA_TYPE_egressInterfaceType                      },
  { IPFIX_TYPEID_rtpSequenceNumber                       , IPFIX_BYTES_unsigned16          ,     0, "rtpSequenceNumber"                     , IPFIX_DATA_TYPE_rtpSequenceNumber                        },
  { IPFIX_TYPEID_userName                                , IPFIX_BYTES_string              ,     0, "userName"                              , IPFIX_DATA_TYPE_userName                                 },
  { IPFIX_TYPEID_applicationCategoryName                 , IPFIX_BYTES_string              ,     0, "applicationCategoryName"               , IPFIX_DATA_TYPE_applicationCategoryName                  },
  { IPFIX_TYPEID_applicationSubCategoryName              , IPFIX_BYTES_string              ,     0, "applicationSubCategoryName"            , IPFIX_DATA_TYPE_applicationSubCategoryName               },
  { IPFIX_TYPEID_applicationGroupName                    , IPFIX_BYTES_string              ,     0, "applicationGroupName"                  , IPFIX_DATA_TYPE_applicationGroupName                     },
  { IPFIX_TYPEID_originalFlowsPresent                    , IPFIX_BYTES_unsigned64          ,     0, "originalFlowsPresent"                  , IPFIX_DATA_TYPE_originalFlowsPresent                     },
  { IPFIX_TYPEID_originalFlowsInitiated                  , IPFIX_BYTES_unsigned64          ,     0, "originalFlowsInitiated"                , IPFIX_DATA_TYPE_originalFlowsInitiated                   },
  { IPFIX_TYPEID_originalFlowsCompleted                  , IPFIX_BYTES_unsigned64          ,     0, "originalFlowsCompleted"                , IPFIX_DATA_TYPE_originalFlowsCompleted                   },
  { IPFIX_TYPEID_distinctCountOfSourceIPAddress          , IPFIX_BYTES_unsigned64          ,     0, "distinctCountOfSourceIPAddress"        , IPFIX_DATA_TYPE_distinctCountOfSourceIPAddress           },
  { IPFIX_TYPEID_distinctCountOfDestinationIPAddress     , IPFIX_BYTES_unsigned64          ,     0, "distinctCountOfDestinationIPAddress"   , IPFIX_DATA_TYPE_distinctCountOfDestinationIPAddress      },
  { IPFIX_TYPEID_distinctCountOfSourceIPv4Address        , IPFIX_BYTES_unsigned32          ,     0, "distinctCountOfSourceIPv4Address"      , IPFIX_DATA_TYPE_distinctCountOfSourceIPv4Address         },
  { IPFIX_TYPEID_distinctCountOfDestinationIPv4Address   , IPFIX_BYTES_unsigned32          ,     0, "distinctCountOfDestinationIPv4Address" , IPFIX_DATA_TYPE_distinctCountOfDestinationIPv4Address    },
  { IPFIX_TYPEID_distinctCountOfSourceIPv6Address        , IPFIX_BYTES_unsigned64          ,     0, "distinctCountOfSourceIPv6Address"      , IPFIX_DATA_TYPE_distinctCountOfSourceIPv6Address         },
  { IPFIX_TYPEID_distinctCountOfDestinationIPv6Address   , IPFIX_BYTES_unsigned64          ,     0, "distinctCountOfDestinationIPv6Address" , IPFIX_DATA_TYPE_distinctCountOfDestinationIPv6Address    },
  { IPFIX_TYPEID_valueDistributionMethod                 , IPFIX_BYTES_unsigned8           ,     0, "valueDistributionMethod"               , IPFIX_DATA_TYPE_valueDistributionMethod                  },
  { IPFIX_TYPEID_rfc3550JitterMilliseconds               , IPFIX_BYTES_unsigned32          ,     0, "rfc3550JitterMilliseconds"             , IPFIX_DATA_TYPE_rfc3550JitterMilliseconds                },
  { IPFIX_TYPEID_rfc3550JitterMicroseconds               , IPFIX_BYTES_unsigned32          ,     0, "rfc3550JitterMicroseconds"             , IPFIX_DATA_TYPE_rfc3550JitterMicroseconds                },
  { IPFIX_TYPEID_rfc3550JitterNanoseconds                , IPFIX_BYTES_unsigned32          ,     0, "rfc3550JitterNanoseconds"              , IPFIX_DATA_TYPE_rfc3550JitterNanoseconds                 },
  { IPFIX_TYPEID_dot1qDEI                                , IPFIX_BYTES_boolean             ,     0, "dot1qDEI"                              , IPFIX_DATA_TYPE_dot1qDEI                                 },
  { IPFIX_TYPEID_dot1qCustomerDEI                        , IPFIX_BYTES_boolean             ,     0, "dot1qCustomerDEI"                      , IPFIX_DATA_TYPE_dot1qCustomerDEI                         },
  { IPFIX_TYPEID_flowSelectorAlgorithm                   , IPFIX_BYTES_unsigned16          ,     0, "flowSelectorAlgorithm"                 , IPFIX_DATA_TYPE_flowSelectorAlgorithm                    },
  { IPFIX_TYPEID_flowSelectedOctetDeltaCount             , IPFIX_BYTES_unsigned64          ,     0, "flowSelectedOctetDeltaCount"           , IPFIX_DATA_TYPE_flowSelectedOctetDeltaCount              },
  { IPFIX_TYPEID_flowSelectedPacketDeltaCount            , IPFIX_BYTES_unsigned64          ,     0, "flowSelectedPacketDeltaCount"          , IPFIX_DATA_TYPE_flowSelectedPacketDeltaCount             },
  { IPFIX_TYPEID_flowSelectedFlowDeltaCount              , IPFIX_BYTES_unsigned64          ,     0, "flowSelectedFlowDeltaCount"            , IPFIX_DATA_TYPE_flowSelectedFlowDeltaCount               },
  { IPFIX_TYPEID_selectorIDTotalFlowsObserved            , IPFIX_BYTES_unsigned64          ,     0, "selectorIDTotalFlowsObserved"          , IPFIX_DATA_TYPE_selectorIDTotalFlowsObserved             },
  { IPFIX_TYPEID_selectorIDTotalFlowsSelected            , IPFIX_BYTES_unsigned64          ,     0, "selectorIDTotalFlowsSelected"          , IPFIX_DATA_TYPE_selectorIDTotalFlowsSelected             },
  { IPFIX_TYPEID_samplingFlowInterval                    , IPFIX_BYTES_unsigned64          ,     0, "samplingFlowInterval"                  , IPFIX_DATA_TYPE_samplingFlowInterval                     },
  { IPFIX_TYPEID_samplingFlowSpacing                     , IPFIX_BYTES_unsigned64          ,     0, "samplingFlowSpacing"                   , IPFIX_DATA_TYPE_samplingFlowSpacing                      },
  { IPFIX_TYPEID_flowSamplingTimeInterval                , IPFIX_BYTES_unsigned64          ,     0, "flowSamplingTimeInterval"              , IPFIX_DATA_TYPE_flowSamplingTimeInterval                 },
  { IPFIX_TYPEID_flowSamplingTimeSpacing                 , IPFIX_BYTES_unsigned64          ,     0, "flowSamplingTimeSpacing"               , IPFIX_DATA_TYPE_flowSamplingTimeSpacing                  },
  { IPFIX_TYPEID_hashFlowDomain                          , IPFIX_BYTES_unsigned16          ,     0, "hashFlowDomain"                        , IPFIX_DATA_TYPE_hashFlowDomain                           },
  { IPFIX_TYPEID_transportOctetDeltaCount                , IPFIX_BYTES_unsigned64          ,     0, "transportOctetDeltaCount"              , IPFIX_DATA_TYPE_transportOctetDeltaCount                 },
  { IPFIX_TYPEID_transportPacketDeltaCount               , IPFIX_BYTES_unsigned64          ,     0, "transportPacketDeltaCount"             , IPFIX_DATA_TYPE_transportPacketDeltaCount                },
  { IPFIX_TYPEID_originalExporterIPv4Address             , IPFIX_BYTES_ipv4Address         ,     0, "originalExporterIPv4Address"           , IPFIX_DATA_TYPE_originalExporterIPv4Address              },
  { IPFIX_TYPEID_originalExporterIPv6Address             , IPFIX_BYTES_ipv6Address         ,     0, "originalExporterIPv6Address"           , IPFIX_DATA_TYPE_originalExporterIPv6Address              },
  { IPFIX_TYPEID_originalObservationDomainId             , IPFIX_BYTES_unsigned32          ,     0, "originalObservationDomainId"           , IPFIX_DATA_TYPE_originalObservationDomainId              },
  { IPFIX_TYPEID_intermediateProcessId                   , IPFIX_BYTES_unsigned32          ,     0, "intermediateProcessId"                 , IPFIX_DATA_TYPE_intermediateProcessId                    },
  { IPFIX_TYPEID_ignoredDataRecordTotalCount             , IPFIX_BYTES_unsigned64          ,     0, "ignoredDataRecordTotalCount"           , IPFIX_DATA_TYPE_ignoredDataRecordTotalCount              },
  { IPFIX_TYPEID_dataLinkFrameType                       , IPFIX_BYTES_unsigned16          ,     0, "dataLinkFrameType"                     , IPFIX_DATA_TYPE_dataLinkFrameType                        },
  { IPFIX_TYPEID_sectionOffset                           , IPFIX_BYTES_unsigned16          ,     0, "sectionOffset"                         , IPFIX_DATA_TYPE_sectionOffset                            },
  { IPFIX_TYPEID_sectionExportedOctets                   , IPFIX_BYTES_unsigned16          ,     0, "sectionExportedOctets"                 , IPFIX_DATA_TYPE_sectionExportedOctets                    },
  { IPFIX_TYPEID_dot1qServiceInstanceTag                 , IPFIX_BYTES_octetArray          ,     0, "dot1qServiceInstanceTag"               , IPFIX_DATA_TYPE_dot1qServiceInstanceTag                  },
  { IPFIX_TYPEID_dot1qServiceInstanceId                  , IPFIX_BYTES_unsigned32          ,     0, "dot1qServiceInstanceId"                , IPFIX_DATA_TYPE_dot1qServiceInstanceId                   },
  { IPFIX_TYPEID_dot1qServiceInstancePriority            , IPFIX_BYTES_unsigned8           ,     0, "dot1qServiceInstancePriority"          , IPFIX_DATA_TYPE_dot1qServiceInstancePriority             },
  { IPFIX_TYPEID_dot1qCustomerSourceMacAddress           , IPFIX_BYTES_macAddress          ,     0, "dot1qCustomerSourceMacAddress"         , IPFIX_DATA_TYPE_dot1qCustomerSourceMacAddress            },
  { IPFIX_TYPEID_dot1qCustomerDestinationMacAddress      , IPFIX_BYTES_macAddress          ,     0, "dot1qCustomerDestinationMacAddress"    , IPFIX_DATA_TYPE_dot1qCustomerDestinationMacAddress       },
  { IPFIX_TYPEID_postLayer2OctetDeltaCount               , IPFIX_BYTES_unsigned64          ,     0, "postLayer2OctetDeltaCount"             , IPFIX_DATA_TYPE_postLayer2OctetDeltaCount                },
  { IPFIX_TYPEID_postMCastLayer2OctetDeltaCount          , IPFIX_BYTES_unsigned64          ,     0, "postMCastLayer2OctetDeltaCount"        , IPFIX_DATA_TYPE_postMCastLayer2OctetDeltaCount           },
  { IPFIX_TYPEID_postLayer2OctetTotalCount               , IPFIX_BYTES_unsigned64          ,     0, "postLayer2OctetTotalCount"             , IPFIX_DATA_TYPE_postLayer2OctetTotalCount                },
  { IPFIX_TYPEID_postMCastLayer2OctetTotalCount          , IPFIX_BYTES_unsigned64          ,     0, "postMCastLayer2OctetTotalCount"        , IPFIX_DATA_TYPE_postMCastLayer2OctetTotalCount           },
  { IPFIX_TYPEID_minimumLayer2TotalLength                , IPFIX_BYTES_unsigned64          ,     0, "minimumLayer2TotalLength"              , IPFIX_DATA_TYPE_minimumLayer2TotalLength                 },
  { IPFIX_TYPEID_maximumLayer2TotalLength                , IPFIX_BYTES_unsigned64          ,     0, "maximumLayer2TotalLength"              , IPFIX_DATA_TYPE_maximumLayer2TotalLength                 },
  { IPFIX_TYPEID_droppedLayer2OctetDeltaCount            , IPFIX_BYTES_unsigned64          ,     0, "droppedLayer2OctetDeltaCount"          , IPFIX_DATA_TYPE_droppedLayer2OctetDeltaCount             },
  { IPFIX_TYPEID_droppedLayer2OctetTotalCount            , IPFIX_BYTES_unsigned64          ,     0, "droppedLayer2OctetTotalCount"          , IPFIX_DATA_TYPE_droppedLayer2OctetTotalCount             },
  { IPFIX_TYPEID_ignoredLayer2OctetTotalCount            , IPFIX_BYTES_unsigned64          ,     0, "ignoredLayer2OctetTotalCount"          , IPFIX_DATA_TYPE_ignoredLayer2OctetTotalCount             },
  { IPFIX_TYPEID_notSentLayer2OctetTotalCount            , IPFIX_BYTES_unsigned64          ,     0, "notSentLayer2OctetTotalCount"          , IPFIX_DATA_TYPE_notSentLayer2OctetTotalCount             },
  { IPFIX_TYPEID_layer2OctetDeltaSumOfSquares            , IPFIX_BYTES_unsigned64          ,     0, "layer2OctetDeltaSumOfSquares"          , IPFIX_DATA_TYPE_layer2OctetDeltaSumOfSquares             },
  { IPFIX_TYPEID_layer2OctetTotalSumOfSquares            , IPFIX_BYTES_unsigned64          ,     0, "layer2OctetTotalSumOfSquares"          , IPFIX_DATA_TYPE_layer2OctetTotalSumOfSquares             },
  { IPFIX_TYPEID_layer2FrameDeltaCount                   , IPFIX_BYTES_unsigned64          ,     0, "layer2FrameDeltaCount"                 , IPFIX_DATA_TYPE_layer2FrameDeltaCount                    },
  { IPFIX_TYPEID_layer2FrameTotalCount                   , IPFIX_BYTES_unsigned64          ,     0, "layer2FrameTotalCount"                 , IPFIX_DATA_TYPE_layer2FrameTotalCount                    },
  { IPFIX_TYPEID_pseudoWireDestinationIPv4Address        , IPFIX_BYTES_ipv4Address         ,     0, "pseudoWireDestinationIPv4Address"      , IPFIX_DATA_TYPE_pseudoWireDestinationIPv4Address         },
  { IPFIX_TYPEID_ignoredLayer2FrameTotalCount            , IPFIX_BYTES_unsigned64          ,     0, "ignoredLayer2FrameTotalCount"          , IPFIX_DATA_TYPE_ignoredLayer2FrameTotalCount             },
  { IPFIX_TYPEID_mibObjectValueInteger                   , IPFIX_BYTES_signed32            ,     0, "mibObjectValueInteger"                 , IPFIX_DATA_TYPE_mibObjectValueInteger                    },
  { IPFIX_TYPEID_mibObjectValueOctetString               , IPFIX_BYTES_octetArray          ,     0, "mibObjectValueOctetString"             , IPFIX_DATA_TYPE_mibObjectValueOctetString                },
  { IPFIX_TYPEID_mibObjectValueOID                       , IPFIX_BYTES_octetArray          ,     0, "mibObjectValueOID"                     , IPFIX_DATA_TYPE_mibObjectValueOID                        },
  { IPFIX_TYPEID_mibObjectValueBits                      , IPFIX_BYTES_octetArray          ,     0, "mibObjectValueBits"                    , IPFIX_DATA_TYPE_mibObjectValueBits                       },
  { IPFIX_TYPEID_mibObjectValueIPAddress                 , IPFIX_BYTES_ipv4Address         ,     0, "mibObjectValueIPAddress"               , IPFIX_DATA_TYPE_mibObjectValueIPAddress                  },
  { IPFIX_TYPEID_mibObjectValueCounter                   , IPFIX_BYTES_unsigned64          ,     0, "mibObjectValueCounter"                 , IPFIX_DATA_TYPE_mibObjectValueCounter                    },
  { IPFIX_TYPEID_mibObjectValueGauge                     , IPFIX_BYTES_unsigned32          ,     0, "mibObjectValueGauge"                   , IPFIX_DATA_TYPE_mibObjectValueGauge                      },
  { IPFIX_TYPEID_mibObjectValueTimeTicks                 , IPFIX_BYTES_unsigned32          ,     0, "mibObjectValueTimeTicks"               , IPFIX_DATA_TYPE_mibObjectValueTimeTicks                  },
  { IPFIX_TYPEID_mibObjectValueUnsigned                  , IPFIX_BYTES_unsigned32          ,     0, "mibObjectValueUnsigned"                , IPFIX_DATA_TYPE_mibObjectValueUnsigned                   },
  { IPFIX_TYPEID_mibObjectValueTable                     , IPFIX_BYTES_subTemplateList     ,     0, "mibObjectValueTable"                   , IPFIX_DATA_TYPE_mibObjectValueTable                      },
  { IPFIX_TYPEID_mibObjectValueRow                       , IPFIX_BYTES_subTemplateList     ,     0, "mibObjectValueRow"                     , IPFIX_DATA_TYPE_mibObjectValueRow                        },
  { IPFIX_TYPEID_mibObjectIdentifier                     , IPFIX_BYTES_octetArray          ,     0, "mibObjectIdentifier"                   , IPFIX_DATA_TYPE_mibObjectIdentifier                      },
  { IPFIX_TYPEID_mibSubIdentifier                        , IPFIX_BYTES_unsigned32          ,     0, "mibSubIdentifier"                      , IPFIX_DATA_TYPE_mibSubIdentifier                         },
  { IPFIX_TYPEID_mibIndexIndicator                       , IPFIX_BYTES_unsigned64          ,     0, "mibIndexIndicator"                     , IPFIX_DATA_TYPE_mibIndexIndicator                        },
  { IPFIX_TYPEID_mibCaptureTimeSemantics                 , IPFIX_BYTES_unsigned8           ,     0, "mibCaptureTimeSemantics"               , IPFIX_DATA_TYPE_mibCaptureTimeSemantics                  },
  { IPFIX_TYPEID_mibContextEngineID                      , IPFIX_BYTES_octetArray          ,     0, "mibContextEngineID"                    , IPFIX_DATA_TYPE_mibContextEngineID                       },
  { IPFIX_TYPEID_mibContextName                          , IPFIX_BYTES_string              ,     0, "mibContextName"                        , IPFIX_DATA_TYPE_mibContextName                           },
  { IPFIX_TYPEID_mibObjectName                           , IPFIX_BYTES_string              ,     0, "mibObjectName"                         , IPFIX_DATA_TYPE_mibObjectName                            },
  { IPFIX_TYPEID_mibObjectDescription                    , IPFIX_BYTES_string              ,     0, "mibObjectDescription"                  , IPFIX_DATA_TYPE_mibObjectDescription                     },
  { IPFIX_TYPEID_mibObjectSyntax                         , IPFIX_BYTES_string              ,     0, "mibObjectSyntax"                       , IPFIX_DATA_TYPE_mibObjectSyntax                          },
  { IPFIX_TYPEID_mibModuleName                           , IPFIX_BYTES_string              ,     0, "mibModuleName"                         , IPFIX_DATA_TYPE_mibModuleName                            },
  { IPFIX_TYPEID_mobileIMSI                              , IPFIX_BYTES_string              ,     0, "mobileIMSI"                            , IPFIX_DATA_TYPE_mobileIMSI                               },
  { IPFIX_TYPEID_mobileMSISDN                            , IPFIX_BYTES_string              ,     0, "mobileMSISDN"                          , IPFIX_DATA_TYPE_mobileMSISDN                             },
  { IPFIX_TYPEID_httpStatusCode                          , IPFIX_BYTES_unsigned16          ,     0, "httpStatusCode"                        , IPFIX_DATA_TYPE_httpStatusCode                           },
  { IPFIX_TYPEID_sourceTransportPortsLimit               , IPFIX_BYTES_unsigned16          ,     0, "sourceTransportPortsLimit"             , IPFIX_DATA_TYPE_sourceTransportPortsLimit                },
  { IPFIX_TYPEID_httpRequestMethod                       , IPFIX_BYTES_string              ,     0, "httpRequestMethod"                     , IPFIX_DATA_TYPE_httpRequestMethod                        },
  { IPFIX_TYPEID_httpRequestHost                         , IPFIX_BYTES_string              ,     0, "httpRequestHost"                       , IPFIX_DATA_TYPE_httpRequestHost                          },
  { IPFIX_TYPEID_httpRequestTarget                       , IPFIX_BYTES_string              ,     0, "httpRequestTarget"                     , IPFIX_DATA_TYPE_httpRequestTarget                        },
  { IPFIX_TYPEID_httpMessageVersion                      , IPFIX_BYTES_string              ,     0, "httpMessageVersion"                    , IPFIX_DATA_TYPE_httpMessageVersion                       },
  { IPFIX_TYPEID_natInstanceID                           , IPFIX_BYTES_unsigned32          ,     0, "natInstanceID"                         , IPFIX_DATA_TYPE_natInstanceID                            },
  { IPFIX_TYPEID_internalAddressRealm                    , IPFIX_BYTES_octetArray          ,     0, "internalAddressRealm"                  , IPFIX_DATA_TYPE_internalAddressRealm                     },
  { IPFIX_TYPEID_externalAddressRealm                    , IPFIX_BYTES_octetArray          ,     0, "externalAddressRealm"                  , IPFIX_DATA_TYPE_externalAddressRealm                     },
  { IPFIX_TYPEID_natQuotaExceededEvent                   , IPFIX_BYTES_unsigned32          ,     0, "natQuotaExceededEvent"                 , IPFIX_DATA_TYPE_natQuotaExceededEvent                    },
  { IPFIX_TYPEID_natThresholdEvent                       , IPFIX_BYTES_unsigned32          ,     0, "natThresholdEvent"                     , IPFIX_DATA_TYPE_natThresholdEvent                        },
  { IPFIX_TYPEID_httpUserAgent                           , IPFIX_BYTES_string              ,     0, "httpUserAgent"                         , IPFIX_DATA_TYPE_httpUserAgent                            },
  { IPFIX_TYPEID_httpContentType                         , IPFIX_BYTES_string              ,     0, "httpContentType"                       , IPFIX_DATA_TYPE_httpContentType                          },
  { IPFIX_TYPEID_httpReasonPhrase                        , IPFIX_BYTES_string              ,     0, "httpReasonPhrase"                      , IPFIX_DATA_TYPE_httpReasonPhrase                         },
};



struct ipfix_semantic ipfixsemantic_iana[] = {
/* IANA registry */
  { IPFIX_STRUCTURED_TYPE_SEMANTIC_noneOf                        , "noneOf"   },
  { IPFIX_STRUCTURED_TYPE_SEMANTIC_exactlyOneOf                  , "exactlyOneOf" },
  { IPFIX_STRUCTURED_TYPE_SEMANTIC_oneOrMoreOf                   , "oneOrMoreOf" },
  { IPFIX_STRUCTURED_TYPE_SEMANTIC_allOf                         , "allOf"    },
  { IPFIX_STRUCTURED_TYPE_SEMANTIC_ordered                       , "ordered"  },
  { IPFIX_STRUCTURED_TYPE_SEMANTIC_undefined                     , "undefined" },
};

#ifdef __cplusplus
}
#endif
