#ifndef IPFIX_IANA_H
#define IPFIX_IANA_H

#include "ipfix_names.h"

#define IPFIX_TYPE_octetArray                            0
#define IPFIX_TYPE_unsigned8                             1
#define IPFIX_TYPE_unsigned16                            2
#define IPFIX_TYPE_unsigned32                            3
#define IPFIX_TYPE_unsigned64                            4
#define IPFIX_TYPE_signed8                               5
#define IPFIX_TYPE_signed16                              6
#define IPFIX_TYPE_signed32                              7
#define IPFIX_TYPE_signed64                              8
#define IPFIX_TYPE_float32                               9
#define IPFIX_TYPE_float64                               10
#define IPFIX_TYPE_boolean                               11
#define IPFIX_TYPE_macAddress                            12
#define IPFIX_TYPE_string                                13
#define IPFIX_TYPE_dateTimeSeconds                       14
#define IPFIX_TYPE_dateTimeMilliseconds                  15
#define IPFIX_TYPE_dateTimeMicroseconds                  16
#define IPFIX_TYPE_dateTimeNanoseconds                   17
#define IPFIX_TYPE_ipv4Address                           18
#define IPFIX_TYPE_ipv6Address                           19
#define IPFIX_TYPE_basicList                             20
#define IPFIX_TYPE_subTemplateList                       21
#define IPFIX_TYPE_subTemplateMultiList                  22

#define IPFIX_BYTES_octetArray                65535
#define IPFIX_BYTES_unsigned8                 1
#define IPFIX_BYTES_unsigned16                2
#define IPFIX_BYTES_unsigned32                4
#define IPFIX_BYTES_unsigned64                8
#define IPFIX_BYTES_signed8                   1
#define IPFIX_BYTES_signed16                  2
#define IPFIX_BYTES_signed32                  4
#define IPFIX_BYTES_signed64                  8
#define IPFIX_BYTES_float32                   4
#define IPFIX_BYTES_float64                   8
#define IPFIX_BYTES_boolean                   1
#define IPFIX_BYTES_macAddress                6
#define IPFIX_BYTES_string                    65535
#define IPFIX_BYTES_dateTimeSeconds           4
#define IPFIX_BYTES_dateTimeMilliseconds      8
#define IPFIX_BYTES_dateTimeMicroseconds      8
#define IPFIX_BYTES_dateTimeNanoseconds       8
#define IPFIX_BYTES_ipv4Address               4
#define IPFIX_BYTES_ipv6Address               16
#define IPFIX_BYTES_basicList                 65535
#define IPFIX_BYTES_subTemplateList           65535
#define IPFIX_BYTES_subTemplateMultiList      65535

#define IPFIX_TYPEID_octetDeltaCount                          1
#define IPFIX_TYPEID_packetDeltaCount                         2
#define IPFIX_TYPEID_deltaFlowCount                           3
#define IPFIX_TYPEID_protocolIdentifier                       4
#define IPFIX_TYPEID_ipClassOfService                         5
#define IPFIX_TYPEID_tcpControlBits                           6
#define IPFIX_TYPEID_sourceTransportPort                      7
#define IPFIX_TYPEID_sourceIPv4Address                        8
#define IPFIX_TYPEID_sourceIPv4PrefixLength                   9
#define IPFIX_TYPEID_ingressInterface                         10
#define IPFIX_TYPEID_destinationTransportPort                 11
#define IPFIX_TYPEID_destinationIPv4Address                   12
#define IPFIX_TYPEID_destinationIPv4PrefixLength              13
#define IPFIX_TYPEID_egressInterface                          14
#define IPFIX_TYPEID_ipNextHopIPv4Address                     15
#define IPFIX_TYPEID_bgpSourceAsNumber                        16
#define IPFIX_TYPEID_bgpDestinationAsNumber                   17
#define IPFIX_TYPEID_bgpNextHopIPv4Address                    18
#define IPFIX_TYPEID_postMCastPacketDeltaCount                19
#define IPFIX_TYPEID_postMCastOctetDeltaCount                 20
#define IPFIX_TYPEID_flowEndSysUpTime                         21
#define IPFIX_TYPEID_flowStartSysUpTime                       22
#define IPFIX_TYPEID_postOctetDeltaCount                      23
#define IPFIX_TYPEID_postPacketDeltaCount                     24
#define IPFIX_TYPEID_minimumIpTotalLength                     25
#define IPFIX_TYPEID_maximumIpTotalLength                     26
#define IPFIX_TYPEID_sourceIPv6Address                        27
#define IPFIX_TYPEID_destinationIPv6Address                   28
#define IPFIX_TYPEID_sourceIPv6PrefixLength                   29
#define IPFIX_TYPEID_destinationIPv6PrefixLength              30
#define IPFIX_TYPEID_flowLabelIPv6                            31
#define IPFIX_TYPEID_icmpTypeCodeIPv4                         32
#define IPFIX_TYPEID_igmpType                                 33
#define IPFIX_TYPEID_flowActiveTimeout                        36
#define IPFIX_TYPEID_flowIdleTimeout                          37
#define IPFIX_TYPEID_exportedOctetTotalCount                  40
#define IPFIX_TYPEID_exportedMessageTotalCount                41
#define IPFIX_TYPEID_exportedFlowRecordTotalCount             42
#define IPFIX_TYPEID_sourceIPv4Prefix                         44
#define IPFIX_TYPEID_destinationIPv4Prefix                    45
#define IPFIX_TYPEID_mplsTopLabelType                         46
#define IPFIX_TYPEID_mplsTopLabelIPv4Address                  47
#define IPFIX_TYPEID_minimumTTL                               52
#define IPFIX_TYPEID_maximumTTL                               53
#define IPFIX_TYPEID_fragmentIdentification                   54
#define IPFIX_TYPEID_postIpClassOfService                     55
#define IPFIX_TYPEID_sourceMacAddress                         56
#define IPFIX_TYPEID_postDestinationMacAddress                57
#define IPFIX_TYPEID_vlanId                                   58
#define IPFIX_TYPEID_postVlanId                               59
#define IPFIX_TYPEID_ipVersion                                60
#define IPFIX_TYPEID_flowDirection                            61
#define IPFIX_TYPEID_ipNextHopIPv6Address                     62
#define IPFIX_TYPEID_bgpNextHopIPv6Address                    63
#define IPFIX_TYPEID_ipv6ExtensionHeaders                     64
#define IPFIX_TYPEID_mplsTopLabelStackSection                 70
#define IPFIX_TYPEID_mplsLabelStackSection2                   71
#define IPFIX_TYPEID_mplsLabelStackSection3                   72
#define IPFIX_TYPEID_mplsLabelStackSection4                   73
#define IPFIX_TYPEID_mplsLabelStackSection5                   74
#define IPFIX_TYPEID_mplsLabelStackSection6                   75
#define IPFIX_TYPEID_mplsLabelStackSection7                   76
#define IPFIX_TYPEID_mplsLabelStackSection8                   77
#define IPFIX_TYPEID_mplsLabelStackSection9                   78
#define IPFIX_TYPEID_mplsLabelStackSection10                  79
#define IPFIX_TYPEID_destinationMacAddress                    80
#define IPFIX_TYPEID_postSourceMacAddress                     81
#define IPFIX_TYPEID_interfaceName                            82
#define IPFIX_TYPEID_interfaceDescription                     83
#define IPFIX_TYPEID_octetTotalCount                          85
#define IPFIX_TYPEID_packetTotalCount                         86
#define IPFIX_TYPEID_fragmentOffset                           88
#define IPFIX_TYPEID_forwardingStatus                         89
#define IPFIX_TYPEID_mplsVpnRouteDistinguisher                90
#define IPFIX_TYPEID_mplsTopLabelPrefixLength                 91
#define IPFIX_TYPEID_srcTrafficIndex                          92
#define IPFIX_TYPEID_dstTrafficIndex                          93
#define IPFIX_TYPEID_applicationDescription                   94
#define IPFIX_TYPEID_applicationId                            95
#define IPFIX_TYPEID_applicationName                          96
#define IPFIX_TYPEID_postIpDiffServCodePoint                  98
#define IPFIX_TYPEID_multicastReplicationFactor               99
#define IPFIX_TYPEID_classificationEngineId                   101
#define IPFIX_TYPEID_bgpNextAdjacentAsNumber                  128
#define IPFIX_TYPEID_bgpPrevAdjacentAsNumber                  129
#define IPFIX_TYPEID_exporterIPv4Address                      130
#define IPFIX_TYPEID_exporterIPv6Address                      131
#define IPFIX_TYPEID_droppedOctetDeltaCount                   132
#define IPFIX_TYPEID_droppedPacketDeltaCount                  133
#define IPFIX_TYPEID_droppedOctetTotalCount                   134
#define IPFIX_TYPEID_droppedPacketTotalCount                  135
#define IPFIX_TYPEID_flowEndReason                            136
#define IPFIX_TYPEID_commonPropertiesId                       137
#define IPFIX_TYPEID_observationPointId                       138
#define IPFIX_TYPEID_icmpTypeCodeIPv6                         139
#define IPFIX_TYPEID_mplsTopLabelIPv6Address                  140
#define IPFIX_TYPEID_lineCardId                               141
#define IPFIX_TYPEID_portId                                   142
#define IPFIX_TYPEID_meteringProcessId                        143
#define IPFIX_TYPEID_exportingProcessId                       144
#define IPFIX_TYPEID_templateId                               145
#define IPFIX_TYPEID_wlanChannelId                            146
#define IPFIX_TYPEID_wlanSSID                                 147
#define IPFIX_TYPEID_flowId                                   148
#define IPFIX_TYPEID_observationDomainId                      149
#define IPFIX_TYPEID_flowStartSeconds                         150
#define IPFIX_TYPEID_flowEndSeconds                           151
#define IPFIX_TYPEID_flowStartMilliseconds                    152
#define IPFIX_TYPEID_flowEndMilliseconds                      153
#define IPFIX_TYPEID_flowStartMicroseconds                    154
#define IPFIX_TYPEID_flowEndMicroseconds                      155
#define IPFIX_TYPEID_flowStartNanoseconds                     156
#define IPFIX_TYPEID_flowEndNanoseconds                       157
#define IPFIX_TYPEID_flowStartDeltaMicroseconds               158
#define IPFIX_TYPEID_flowEndDeltaMicroseconds                 159
#define IPFIX_TYPEID_systemInitTimeMilliseconds               160
#define IPFIX_TYPEID_flowDurationMilliseconds                 161
#define IPFIX_TYPEID_flowDurationMicroseconds                 162
#define IPFIX_TYPEID_observedFlowTotalCount                   163
#define IPFIX_TYPEID_ignoredPacketTotalCount                  164
#define IPFIX_TYPEID_ignoredOctetTotalCount                   165
#define IPFIX_TYPEID_notSentFlowTotalCount                    166
#define IPFIX_TYPEID_notSentPacketTotalCount                  167
#define IPFIX_TYPEID_notSentOctetTotalCount                   168
#define IPFIX_TYPEID_destinationIPv6Prefix                    169
#define IPFIX_TYPEID_sourceIPv6Prefix                         170
#define IPFIX_TYPEID_postOctetTotalCount                      171
#define IPFIX_TYPEID_postPacketTotalCount                     172
#define IPFIX_TYPEID_flowKeyIndicator                         173
#define IPFIX_TYPEID_postMCastPacketTotalCount                174
#define IPFIX_TYPEID_postMCastOctetTotalCount                 175
#define IPFIX_TYPEID_icmpTypeIPv4                             176
#define IPFIX_TYPEID_icmpCodeIPv4                             177
#define IPFIX_TYPEID_icmpTypeIPv6                             178
#define IPFIX_TYPEID_icmpCodeIPv6                             179
#define IPFIX_TYPEID_udpSourcePort                            180
#define IPFIX_TYPEID_udpDestinationPort                       181
#define IPFIX_TYPEID_tcpSourcePort                            182
#define IPFIX_TYPEID_tcpDestinationPort                       183
#define IPFIX_TYPEID_tcpSequenceNumber                        184
#define IPFIX_TYPEID_tcpAcknowledgementNumber                 185
#define IPFIX_TYPEID_tcpWindowSize                            186
#define IPFIX_TYPEID_tcpUrgentPointer                         187
#define IPFIX_TYPEID_tcpHeaderLength                          188
#define IPFIX_TYPEID_ipHeaderLength                           189
#define IPFIX_TYPEID_totalLengthIPv4                          190
#define IPFIX_TYPEID_payloadLengthIPv6                        191
#define IPFIX_TYPEID_ipTTL                                    192
#define IPFIX_TYPEID_nextHeaderIPv6                           193
#define IPFIX_TYPEID_mplsPayloadLength                        194
#define IPFIX_TYPEID_ipDiffServCodePoint                      195
#define IPFIX_TYPEID_ipPrecedence                             196
#define IPFIX_TYPEID_fragmentFlags                            197
#define IPFIX_TYPEID_octetDeltaSumOfSquares                   198
#define IPFIX_TYPEID_octetTotalSumOfSquares                   199
#define IPFIX_TYPEID_mplsTopLabelTTL                          200
#define IPFIX_TYPEID_mplsLabelStackLength                     201
#define IPFIX_TYPEID_mplsLabelStackDepth                      202
#define IPFIX_TYPEID_mplsTopLabelExp                          203
#define IPFIX_TYPEID_ipPayloadLength                          204
#define IPFIX_TYPEID_udpMessageLength                         205
#define IPFIX_TYPEID_isMulticast                              206
#define IPFIX_TYPEID_ipv4IHL                                  207
#define IPFIX_TYPEID_ipv4Options                              208
#define IPFIX_TYPEID_tcpOptions                               209
#define IPFIX_TYPEID_paddingOctets                            210
#define IPFIX_TYPEID_collectorIPv4Address                     211
#define IPFIX_TYPEID_collectorIPv6Address                     212
#define IPFIX_TYPEID_exportInterface                          213
#define IPFIX_TYPEID_exportProtocolVersion                    214
#define IPFIX_TYPEID_exportTransportProtocol                  215
#define IPFIX_TYPEID_collectorTransportPort                   216
#define IPFIX_TYPEID_exporterTransportPort                    217
#define IPFIX_TYPEID_tcpSynTotalCount                         218
#define IPFIX_TYPEID_tcpFinTotalCount                         219
#define IPFIX_TYPEID_tcpRstTotalCount                         220
#define IPFIX_TYPEID_tcpPshTotalCount                         221
#define IPFIX_TYPEID_tcpAckTotalCount                         222
#define IPFIX_TYPEID_tcpUrgTotalCount                         223
#define IPFIX_TYPEID_ipTotalLength                            224
#define IPFIX_TYPEID_postNATSourceIPv4Address                 225
#define IPFIX_TYPEID_postNATDestinationIPv4Address            226
#define IPFIX_TYPEID_postNAPTSourceTransportPort              227
#define IPFIX_TYPEID_postNAPTDestinationTransportPort         228
#define IPFIX_TYPEID_natOriginatingAddressRealm               229
#define IPFIX_TYPEID_natEvent                                 230
#define IPFIX_TYPEID_initiatorOctets                          231
#define IPFIX_TYPEID_responderOctets                          232
#define IPFIX_TYPEID_firewallEvent                            233
#define IPFIX_TYPEID_ingressVRFID                             234
#define IPFIX_TYPEID_egressVRFID                              235
#define IPFIX_TYPEID_VRFname                                  236
#define IPFIX_TYPEID_postMplsTopLabelExp                      237
#define IPFIX_TYPEID_tcpWindowScale                           238
#define IPFIX_TYPEID_biflowDirection                          239
#define IPFIX_TYPEID_ethernetHeaderLength                     240
#define IPFIX_TYPEID_ethernetPayloadLength                    241
#define IPFIX_TYPEID_ethernetTotalLength                      242
#define IPFIX_TYPEID_dot1qVlanId                              243
#define IPFIX_TYPEID_dot1qPriority                            244
#define IPFIX_TYPEID_dot1qCustomerVlanId                      245
#define IPFIX_TYPEID_dot1qCustomerPriority                    246
#define IPFIX_TYPEID_metroEvcId                               247
#define IPFIX_TYPEID_metroEvcType                             248
#define IPFIX_TYPEID_pseudoWireId                             249
#define IPFIX_TYPEID_pseudoWireType                           250
#define IPFIX_TYPEID_pseudoWireControlWord                    251
#define IPFIX_TYPEID_ingressPhysicalInterface                 252
#define IPFIX_TYPEID_egressPhysicalInterface                  253
#define IPFIX_TYPEID_postDot1qVlanId                          254
#define IPFIX_TYPEID_postDot1qCustomerVlanId                  255
#define IPFIX_TYPEID_ethernetType                             256
#define IPFIX_TYPEID_postIpPrecedence                         257
#define IPFIX_TYPEID_collectionTimeMilliseconds               258
#define IPFIX_TYPEID_exportSctpStreamId                       259
#define IPFIX_TYPEID_maxExportSeconds                         260
#define IPFIX_TYPEID_maxFlowEndSeconds                        261
#define IPFIX_TYPEID_messageMD5Checksum                       262
#define IPFIX_TYPEID_messageScope                             263
#define IPFIX_TYPEID_minExportSeconds                         264
#define IPFIX_TYPEID_minFlowStartSeconds                      265
#define IPFIX_TYPEID_opaqueOctets                             266
#define IPFIX_TYPEID_sessionScope                             267
#define IPFIX_TYPEID_maxFlowEndMicroseconds                   268
#define IPFIX_TYPEID_maxFlowEndMilliseconds                   269
#define IPFIX_TYPEID_maxFlowEndNanoseconds                    270
#define IPFIX_TYPEID_minFlowStartMicroseconds                 271
#define IPFIX_TYPEID_minFlowStartMilliseconds                 272
#define IPFIX_TYPEID_minFlowStartNanoseconds                  273
#define IPFIX_TYPEID_collectorCertificate                     274
#define IPFIX_TYPEID_exporterCertificate                      275
#define IPFIX_TYPEID_dataRecordsReliability                   276
#define IPFIX_TYPEID_observationPointType                     277
#define IPFIX_TYPEID_newConnectionDeltaCount                  278
#define IPFIX_TYPEID_connectionSumDurationSeconds             279
#define IPFIX_TYPEID_connectionTransactionId                  280
#define IPFIX_TYPEID_postNATSourceIPv6Address                 281
#define IPFIX_TYPEID_postNATDestinationIPv6Address            282
#define IPFIX_TYPEID_natPoolId                                283
#define IPFIX_TYPEID_natPoolName                              284
#define IPFIX_TYPEID_anonymizationFlags                       285
#define IPFIX_TYPEID_anonymizationTechnique                   286
#define IPFIX_TYPEID_informationElementIndex                  287
#define IPFIX_TYPEID_p2pTechnology                            288
#define IPFIX_TYPEID_tunnelTechnology                         289
#define IPFIX_TYPEID_encryptedTechnology                      290
#define IPFIX_TYPEID_basicList                                291
#define IPFIX_TYPEID_subTemplateList                          292
#define IPFIX_TYPEID_subTemplateMultiList                     293
#define IPFIX_TYPEID_bgpValidityState                         294
#define IPFIX_TYPEID_IPSecSPI                                 295
#define IPFIX_TYPEID_greKey                                   296
#define IPFIX_TYPEID_natType                                  297
#define IPFIX_TYPEID_initiatorPackets                         298
#define IPFIX_TYPEID_responderPackets                         299
#define IPFIX_TYPEID_observationDomainName                    300
#define IPFIX_TYPEID_selectionSequenceId                      301
#define IPFIX_TYPEID_selectorId                               302
#define IPFIX_TYPEID_informationElementId                     303
#define IPFIX_TYPEID_selectorAlgorithm                        304
#define IPFIX_TYPEID_samplingPacketInterval                   305
#define IPFIX_TYPEID_samplingPacketSpace                      306
#define IPFIX_TYPEID_samplingTimeInterval                     307
#define IPFIX_TYPEID_samplingTimeSpace                        308
#define IPFIX_TYPEID_samplingSize                             309
#define IPFIX_TYPEID_samplingPopulation                       310
#define IPFIX_TYPEID_samplingProbability                      311
#define IPFIX_TYPEID_dataLinkFrameSize                        312
#define IPFIX_TYPEID_ipHeaderPacketSection                    313
#define IPFIX_TYPEID_ipPayloadPacketSection                   314
#define IPFIX_TYPEID_dataLinkFrameSection                     315
#define IPFIX_TYPEID_mplsLabelStackSection                    316
#define IPFIX_TYPEID_mplsPayloadPacketSection                 317
#define IPFIX_TYPEID_selectorIdTotalPktsObserved              318
#define IPFIX_TYPEID_selectorIdTotalPktsSelected              319
#define IPFIX_TYPEID_absoluteError                            320
#define IPFIX_TYPEID_relativeError                            321
#define IPFIX_TYPEID_observationTimeSeconds                   322
#define IPFIX_TYPEID_observationTimeMilliseconds              323
#define IPFIX_TYPEID_observationTimeMicroseconds              324
#define IPFIX_TYPEID_observationTimeNanoseconds               325
#define IPFIX_TYPEID_digestHashValue                          326
#define IPFIX_TYPEID_hashIPPayloadOffset                      327
#define IPFIX_TYPEID_hashIPPayloadSize                        328
#define IPFIX_TYPEID_hashOutputRangeMin                       329
#define IPFIX_TYPEID_hashOutputRangeMax                       330
#define IPFIX_TYPEID_hashSelectedRangeMin                     331
#define IPFIX_TYPEID_hashSelectedRangeMax                     332
#define IPFIX_TYPEID_hashDigestOutput                         333
#define IPFIX_TYPEID_hashInitialiserValue                     334
#define IPFIX_TYPEID_selectorName                             335
#define IPFIX_TYPEID_upperCILimit                             336
#define IPFIX_TYPEID_lowerCILimit                             337
#define IPFIX_TYPEID_confidenceLevel                          338
#define IPFIX_TYPEID_informationElementDataType               339
#define IPFIX_TYPEID_informationElementDescription            340
#define IPFIX_TYPEID_informationElementName                   341
#define IPFIX_TYPEID_informationElementRangeBegin             342
#define IPFIX_TYPEID_informationElementRangeEnd               343
#define IPFIX_TYPEID_informationElementSemantics              344
#define IPFIX_TYPEID_informationElementUnits                  345
#define IPFIX_TYPEID_privateEnterpriseNumber                  346
#define IPFIX_TYPEID_virtualStationInterfaceId                347
#define IPFIX_TYPEID_virtualStationInterfaceName              348
#define IPFIX_TYPEID_virtualStationUUID                       349
#define IPFIX_TYPEID_virtualStationName                       350
#define IPFIX_TYPEID_layer2SegmentId                          351
#define IPFIX_TYPEID_layer2OctetDeltaCount                    352
#define IPFIX_TYPEID_layer2OctetTotalCount                    353
#define IPFIX_TYPEID_ingressUnicastPacketTotalCount           354
#define IPFIX_TYPEID_ingressMulticastPacketTotalCount         355
#define IPFIX_TYPEID_ingressBroadcastPacketTotalCount         356
#define IPFIX_TYPEID_egressUnicastPacketTotalCount            357
#define IPFIX_TYPEID_egressBroadcastPacketTotalCount          358
#define IPFIX_TYPEID_monitoringIntervalStartMilliSeconds      359
#define IPFIX_TYPEID_monitoringIntervalEndMilliSeconds        360
#define IPFIX_TYPEID_portRangeStart                           361
#define IPFIX_TYPEID_portRangeEnd                             362
#define IPFIX_TYPEID_portRangeStepSize                        363
#define IPFIX_TYPEID_portRangeNumPorts                        364
#define IPFIX_TYPEID_staMacAddress                            365
#define IPFIX_TYPEID_staIPv4Address                           366
#define IPFIX_TYPEID_wtpMacAddress                            367
#define IPFIX_TYPEID_ingressInterfaceType                     368
#define IPFIX_TYPEID_egressInterfaceType                      369
#define IPFIX_TYPEID_rtpSequenceNumber                        370
#define IPFIX_TYPEID_userName                                 371
#define IPFIX_TYPEID_applicationCategoryName                  372
#define IPFIX_TYPEID_applicationSubCategoryName               373
#define IPFIX_TYPEID_applicationGroupName                     374
#define IPFIX_TYPEID_originalFlowsPresent                     375
#define IPFIX_TYPEID_originalFlowsInitiated                   376
#define IPFIX_TYPEID_originalFlowsCompleted                   377
#define IPFIX_TYPEID_distinctCountOfSourceIPAddress           378
#define IPFIX_TYPEID_distinctCountOfDestinationIPAddress      379
#define IPFIX_TYPEID_distinctCountOfSourceIPv4Address         380
#define IPFIX_TYPEID_distinctCountOfDestinationIPv4Address    381
#define IPFIX_TYPEID_distinctCountOfSourceIPv6Address         382
#define IPFIX_TYPEID_distinctCountOfDestinationIPv6Address    383
#define IPFIX_TYPEID_valueDistributionMethod                  384
#define IPFIX_TYPEID_rfc3550JitterMilliseconds                385
#define IPFIX_TYPEID_rfc3550JitterMicroseconds                386
#define IPFIX_TYPEID_rfc3550JitterNanoseconds                 387
#define IPFIX_TYPEID_dot1qDEI                                 388
#define IPFIX_TYPEID_dot1qCustomerDEI                         389
#define IPFIX_TYPEID_flowSelectorAlgorithm                    390
#define IPFIX_TYPEID_flowSelectedOctetDeltaCount              391
#define IPFIX_TYPEID_flowSelectedPacketDeltaCount             392
#define IPFIX_TYPEID_flowSelectedFlowDeltaCount               393
#define IPFIX_TYPEID_selectorIDTotalFlowsObserved             394
#define IPFIX_TYPEID_selectorIDTotalFlowsSelected             395
#define IPFIX_TYPEID_samplingFlowInterval                     396
#define IPFIX_TYPEID_samplingFlowSpacing                      397
#define IPFIX_TYPEID_flowSamplingTimeInterval                 398
#define IPFIX_TYPEID_flowSamplingTimeSpacing                  399
#define IPFIX_TYPEID_hashFlowDomain                           400
#define IPFIX_TYPEID_transportOctetDeltaCount                 401
#define IPFIX_TYPEID_transportPacketDeltaCount                402
#define IPFIX_TYPEID_originalExporterIPv4Address              403
#define IPFIX_TYPEID_originalExporterIPv6Address              404
#define IPFIX_TYPEID_originalObservationDomainId              405
#define IPFIX_TYPEID_intermediateProcessId                    406
#define IPFIX_TYPEID_ignoredDataRecordTotalCount              407
#define IPFIX_TYPEID_dataLinkFrameType                        408
#define IPFIX_TYPEID_sectionOffset                            409
#define IPFIX_TYPEID_sectionExportedOctets                    410
#define IPFIX_TYPEID_dot1qServiceInstanceTag                  411
#define IPFIX_TYPEID_dot1qServiceInstanceId                   412
#define IPFIX_TYPEID_dot1qServiceInstancePriority             413
#define IPFIX_TYPEID_dot1qCustomerSourceMacAddress            414
#define IPFIX_TYPEID_dot1qCustomerDestinationMacAddress       415
#define IPFIX_TYPEID_postLayer2OctetDeltaCount                417
#define IPFIX_TYPEID_postMCastLayer2OctetDeltaCount           418
#define IPFIX_TYPEID_postLayer2OctetTotalCount                420
#define IPFIX_TYPEID_postMCastLayer2OctetTotalCount           421
#define IPFIX_TYPEID_minimumLayer2TotalLength                 422
#define IPFIX_TYPEID_maximumLayer2TotalLength                 423
#define IPFIX_TYPEID_droppedLayer2OctetDeltaCount             424
#define IPFIX_TYPEID_droppedLayer2OctetTotalCount             425
#define IPFIX_TYPEID_ignoredLayer2OctetTotalCount             426
#define IPFIX_TYPEID_notSentLayer2OctetTotalCount             427
#define IPFIX_TYPEID_layer2OctetDeltaSumOfSquares             428
#define IPFIX_TYPEID_layer2OctetTotalSumOfSquares             429
#define IPFIX_TYPEID_layer2FrameDeltaCount                    430
#define IPFIX_TYPEID_layer2FrameTotalCount                    431
#define IPFIX_TYPEID_pseudoWireDestinationIPv4Address         432
#define IPFIX_TYPEID_ignoredLayer2FrameTotalCount             433
#define IPFIX_TYPEID_mibObjectValueInteger                    434
#define IPFIX_TYPEID_mibObjectValueOctetString                435
#define IPFIX_TYPEID_mibObjectValueOID                        436
#define IPFIX_TYPEID_mibObjectValueBits                       437
#define IPFIX_TYPEID_mibObjectValueIPAddress                  438
#define IPFIX_TYPEID_mibObjectValueCounter                    439
#define IPFIX_TYPEID_mibObjectValueGauge                      440
#define IPFIX_TYPEID_mibObjectValueTimeTicks                  441
#define IPFIX_TYPEID_mibObjectValueUnsigned                   442
#define IPFIX_TYPEID_mibObjectValueTable                      443
#define IPFIX_TYPEID_mibObjectValueRow                        444
#define IPFIX_TYPEID_mibObjectIdentifier                      445
#define IPFIX_TYPEID_mibSubIdentifier                         446
#define IPFIX_TYPEID_mibIndexIndicator                        447
#define IPFIX_TYPEID_mibCaptureTimeSemantics                  448
#define IPFIX_TYPEID_mibContextEngineID                       449
#define IPFIX_TYPEID_mibContextName                           450
#define IPFIX_TYPEID_mibObjectName                            451
#define IPFIX_TYPEID_mibObjectDescription                     452
#define IPFIX_TYPEID_mibObjectSyntax                          453
#define IPFIX_TYPEID_mibModuleName                            454
#define IPFIX_TYPEID_mobileIMSI                               455
#define IPFIX_TYPEID_mobileMSISDN                             456
#define IPFIX_TYPEID_httpStatusCode                           457
#define IPFIX_TYPEID_sourceTransportPortsLimit                458
#define IPFIX_TYPEID_httpRequestMethod                        459
#define IPFIX_TYPEID_httpRequestHost                          460
#define IPFIX_TYPEID_httpRequestTarget                        461
#define IPFIX_TYPEID_httpMessageVersion                       462
#define IPFIX_TYPEID_natInstanceID                            463
#define IPFIX_TYPEID_internalAddressRealm                     464
#define IPFIX_TYPEID_externalAddressRealm                     465
#define IPFIX_TYPEID_natQuotaExceededEvent                    466
#define IPFIX_TYPEID_natThresholdEvent                        467
#define IPFIX_TYPEID_httpUserAgent                            468
#define IPFIX_TYPEID_httpContentType                          469
#define IPFIX_TYPEID_httpReasonPhrase                         470

#define IPFIX_LENGTH_octetDeltaCount                          IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_packetDeltaCount                         IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_deltaFlowCount                           IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_protocolIdentifier                       IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_ipClassOfService                         IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_tcpControlBits                           IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_sourceTransportPort                      IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_sourceIPv4Address                        IPFIX_BYTES_ipv4Address
#define IPFIX_LENGTH_sourceIPv4PrefixLength                   IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_ingressInterface                         IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_destinationTransportPort                 IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_destinationIPv4Address                   IPFIX_BYTES_ipv4Address
#define IPFIX_LENGTH_destinationIPv4PrefixLength              IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_egressInterface                          IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_ipNextHopIPv4Address                     IPFIX_BYTES_ipv4Address
#define IPFIX_LENGTH_bgpSourceAsNumber                        IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_bgpDestinationAsNumber                   IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_bgpNextHopIPv4Address                    IPFIX_BYTES_ipv4Address
#define IPFIX_LENGTH_postMCastPacketDeltaCount                IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_postMCastOctetDeltaCount                 IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_flowEndSysUpTime                         IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_flowStartSysUpTime                       IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_postOctetDeltaCount                      IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_postPacketDeltaCount                     IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_minimumIpTotalLength                     IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_maximumIpTotalLength                     IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_sourceIPv6Address                        IPFIX_BYTES_ipv6Address
#define IPFIX_LENGTH_destinationIPv6Address                   IPFIX_BYTES_ipv6Address
#define IPFIX_LENGTH_sourceIPv6PrefixLength                   IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_destinationIPv6PrefixLength              IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_flowLabelIPv6                            IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_icmpTypeCodeIPv4                         IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_igmpType                                 IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_flowActiveTimeout                        IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_flowIdleTimeout                          IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_exportedOctetTotalCount                  IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_exportedMessageTotalCount                IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_exportedFlowRecordTotalCount             IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_sourceIPv4Prefix                         IPFIX_BYTES_ipv4Address
#define IPFIX_LENGTH_destinationIPv4Prefix                    IPFIX_BYTES_ipv4Address
#define IPFIX_LENGTH_mplsTopLabelType                         IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_mplsTopLabelIPv4Address                  IPFIX_BYTES_ipv4Address
#define IPFIX_LENGTH_minimumTTL                               IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_maximumTTL                               IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_fragmentIdentification                   IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_postIpClassOfService                     IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_sourceMacAddress                         IPFIX_BYTES_macAddress
#define IPFIX_LENGTH_postDestinationMacAddress                IPFIX_BYTES_macAddress
#define IPFIX_LENGTH_vlanId                                   IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_postVlanId                               IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_ipVersion                                IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_flowDirection                            IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_ipNextHopIPv6Address                     IPFIX_BYTES_ipv6Address
#define IPFIX_LENGTH_bgpNextHopIPv6Address                    IPFIX_BYTES_ipv6Address
#define IPFIX_LENGTH_ipv6ExtensionHeaders                     IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_mplsTopLabelStackSection                 IPFIX_BYTES_octetArray
#define IPFIX_LENGTH_mplsLabelStackSection2                   IPFIX_BYTES_octetArray
#define IPFIX_LENGTH_mplsLabelStackSection3                   IPFIX_BYTES_octetArray
#define IPFIX_LENGTH_mplsLabelStackSection4                   IPFIX_BYTES_octetArray
#define IPFIX_LENGTH_mplsLabelStackSection5                   IPFIX_BYTES_octetArray
#define IPFIX_LENGTH_mplsLabelStackSection6                   IPFIX_BYTES_octetArray
#define IPFIX_LENGTH_mplsLabelStackSection7                   IPFIX_BYTES_octetArray
#define IPFIX_LENGTH_mplsLabelStackSection8                   IPFIX_BYTES_octetArray
#define IPFIX_LENGTH_mplsLabelStackSection9                   IPFIX_BYTES_octetArray
#define IPFIX_LENGTH_mplsLabelStackSection10                  IPFIX_BYTES_octetArray
#define IPFIX_LENGTH_destinationMacAddress                    IPFIX_BYTES_macAddress
#define IPFIX_LENGTH_postSourceMacAddress                     IPFIX_BYTES_macAddress
#define IPFIX_LENGTH_interfaceName                            IPFIX_BYTES_string
#define IPFIX_LENGTH_interfaceDescription                     IPFIX_BYTES_string
#define IPFIX_LENGTH_octetTotalCount                          IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_packetTotalCount                         IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_fragmentOffset                           IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_forwardingStatus                         IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_mplsVpnRouteDistinguisher                IPFIX_BYTES_octetArray
#define IPFIX_LENGTH_mplsTopLabelPrefixLength                 IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_srcTrafficIndex                          IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_dstTrafficIndex                          IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_applicationDescription                   IPFIX_BYTES_string
#define IPFIX_LENGTH_applicationId                            IPFIX_BYTES_octetArray
#define IPFIX_LENGTH_applicationName                          IPFIX_BYTES_string
#define IPFIX_LENGTH_postIpDiffServCodePoint                  IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_multicastReplicationFactor               IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_classificationEngineId                   IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_bgpNextAdjacentAsNumber                  IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_bgpPrevAdjacentAsNumber                  IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_exporterIPv4Address                      IPFIX_BYTES_ipv4Address
#define IPFIX_LENGTH_exporterIPv6Address                      IPFIX_BYTES_ipv6Address
#define IPFIX_LENGTH_droppedOctetDeltaCount                   IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_droppedPacketDeltaCount                  IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_droppedOctetTotalCount                   IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_droppedPacketTotalCount                  IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_flowEndReason                            IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_commonPropertiesId                       IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_observationPointId                       IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_icmpTypeCodeIPv6                         IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_mplsTopLabelIPv6Address                  IPFIX_BYTES_ipv6Address
#define IPFIX_LENGTH_lineCardId                               IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_portId                                   IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_meteringProcessId                        IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_exportingProcessId                       IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_templateId                               IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_wlanChannelId                            IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_wlanSSID                                 IPFIX_BYTES_string
#define IPFIX_LENGTH_flowId                                   IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_observationDomainId                      IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_flowStartSeconds                         IPFIX_BYTES_dateTimeSeconds
#define IPFIX_LENGTH_flowEndSeconds                           IPFIX_BYTES_dateTimeSeconds
#define IPFIX_LENGTH_flowStartMilliseconds                    IPFIX_BYTES_dateTimeMilliseconds
#define IPFIX_LENGTH_flowEndMilliseconds                      IPFIX_BYTES_dateTimeMilliseconds
#define IPFIX_LENGTH_flowStartMicroseconds                    IPFIX_BYTES_dateTimeMicroseconds
#define IPFIX_LENGTH_flowEndMicroseconds                      IPFIX_BYTES_dateTimeMicroseconds
#define IPFIX_LENGTH_flowStartNanoseconds                     IPFIX_BYTES_dateTimeNanoseconds
#define IPFIX_LENGTH_flowEndNanoseconds                       IPFIX_BYTES_dateTimeNanoseconds
#define IPFIX_LENGTH_flowStartDeltaMicroseconds               IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_flowEndDeltaMicroseconds                 IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_systemInitTimeMilliseconds               IPFIX_BYTES_dateTimeMilliseconds
#define IPFIX_LENGTH_flowDurationMilliseconds                 IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_flowDurationMicroseconds                 IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_observedFlowTotalCount                   IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_ignoredPacketTotalCount                  IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_ignoredOctetTotalCount                   IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_notSentFlowTotalCount                    IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_notSentPacketTotalCount                  IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_notSentOctetTotalCount                   IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_destinationIPv6Prefix                    IPFIX_BYTES_ipv6Address
#define IPFIX_LENGTH_sourceIPv6Prefix                         IPFIX_BYTES_ipv6Address
#define IPFIX_LENGTH_postOctetTotalCount                      IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_postPacketTotalCount                     IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_flowKeyIndicator                         IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_postMCastPacketTotalCount                IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_postMCastOctetTotalCount                 IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_icmpTypeIPv4                             IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_icmpCodeIPv4                             IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_icmpTypeIPv6                             IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_icmpCodeIPv6                             IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_udpSourcePort                            IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_udpDestinationPort                       IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_tcpSourcePort                            IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_tcpDestinationPort                       IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_tcpSequenceNumber                        IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_tcpAcknowledgementNumber                 IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_tcpWindowSize                            IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_tcpUrgentPointer                         IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_tcpHeaderLength                          IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_ipHeaderLength                           IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_totalLengthIPv4                          IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_payloadLengthIPv6                        IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_ipTTL                                    IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_nextHeaderIPv6                           IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_mplsPayloadLength                        IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_ipDiffServCodePoint                      IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_ipPrecedence                             IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_fragmentFlags                            IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_octetDeltaSumOfSquares                   IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_octetTotalSumOfSquares                   IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_mplsTopLabelTTL                          IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_mplsLabelStackLength                     IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_mplsLabelStackDepth                      IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_mplsTopLabelExp                          IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_ipPayloadLength                          IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_udpMessageLength                         IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_isMulticast                              IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_ipv4IHL                                  IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_ipv4Options                              IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_tcpOptions                               IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_paddingOctets                            IPFIX_BYTES_octetArray
#define IPFIX_LENGTH_collectorIPv4Address                     IPFIX_BYTES_ipv4Address
#define IPFIX_LENGTH_collectorIPv6Address                     IPFIX_BYTES_ipv6Address
#define IPFIX_LENGTH_exportInterface                          IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_exportProtocolVersion                    IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_exportTransportProtocol                  IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_collectorTransportPort                   IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_exporterTransportPort                    IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_tcpSynTotalCount                         IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_tcpFinTotalCount                         IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_tcpRstTotalCount                         IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_tcpPshTotalCount                         IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_tcpAckTotalCount                         IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_tcpUrgTotalCount                         IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_ipTotalLength                            IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_postNATSourceIPv4Address                 IPFIX_BYTES_ipv4Address
#define IPFIX_LENGTH_postNATDestinationIPv4Address            IPFIX_BYTES_ipv4Address
#define IPFIX_LENGTH_postNAPTSourceTransportPort              IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_postNAPTDestinationTransportPort         IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_natOriginatingAddressRealm               IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_natEvent                                 IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_initiatorOctets                          IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_responderOctets                          IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_firewallEvent                            IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_ingressVRFID                             IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_egressVRFID                              IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_VRFname                                  IPFIX_BYTES_string
#define IPFIX_LENGTH_postMplsTopLabelExp                      IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_tcpWindowScale                           IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_biflowDirection                          IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_ethernetHeaderLength                     IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_ethernetPayloadLength                    IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_ethernetTotalLength                      IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_dot1qVlanId                              IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_dot1qPriority                            IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_dot1qCustomerVlanId                      IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_dot1qCustomerPriority                    IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_metroEvcId                               IPFIX_BYTES_string
#define IPFIX_LENGTH_metroEvcType                             IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_pseudoWireId                             IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_pseudoWireType                           IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_pseudoWireControlWord                    IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_ingressPhysicalInterface                 IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_egressPhysicalInterface                  IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_postDot1qVlanId                          IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_postDot1qCustomerVlanId                  IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_ethernetType                             IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_postIpPrecedence                         IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_collectionTimeMilliseconds               IPFIX_BYTES_dateTimeMilliseconds
#define IPFIX_LENGTH_exportSctpStreamId                       IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_maxExportSeconds                         IPFIX_BYTES_dateTimeSeconds
#define IPFIX_LENGTH_maxFlowEndSeconds                        IPFIX_BYTES_dateTimeSeconds
#define IPFIX_LENGTH_messageMD5Checksum                       IPFIX_BYTES_octetArray
#define IPFIX_LENGTH_messageScope                             IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_minExportSeconds                         IPFIX_BYTES_dateTimeSeconds
#define IPFIX_LENGTH_minFlowStartSeconds                      IPFIX_BYTES_dateTimeSeconds
#define IPFIX_LENGTH_opaqueOctets                             IPFIX_BYTES_octetArray
#define IPFIX_LENGTH_sessionScope                             IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_maxFlowEndMicroseconds                   IPFIX_BYTES_dateTimeMicroseconds
#define IPFIX_LENGTH_maxFlowEndMilliseconds                   IPFIX_BYTES_dateTimeMilliseconds
#define IPFIX_LENGTH_maxFlowEndNanoseconds                    IPFIX_BYTES_dateTimeNanoseconds
#define IPFIX_LENGTH_minFlowStartMicroseconds                 IPFIX_BYTES_dateTimeMicroseconds
#define IPFIX_LENGTH_minFlowStartMilliseconds                 IPFIX_BYTES_dateTimeMilliseconds
#define IPFIX_LENGTH_minFlowStartNanoseconds                  IPFIX_BYTES_dateTimeNanoseconds
#define IPFIX_LENGTH_collectorCertificate                     IPFIX_BYTES_octetArray
#define IPFIX_LENGTH_exporterCertificate                      IPFIX_BYTES_octetArray
#define IPFIX_LENGTH_dataRecordsReliability                   IPFIX_BYTES_boolean
#define IPFIX_LENGTH_observationPointType                     IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_newConnectionDeltaCount                  IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_connectionSumDurationSeconds             IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_connectionTransactionId                  IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_postNATSourceIPv6Address                 IPFIX_BYTES_ipv6Address
#define IPFIX_LENGTH_postNATDestinationIPv6Address            IPFIX_BYTES_ipv6Address
#define IPFIX_LENGTH_natPoolId                                IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_natPoolName                              IPFIX_BYTES_string
#define IPFIX_LENGTH_anonymizationFlags                       IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_anonymizationTechnique                   IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_informationElementIndex                  IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_p2pTechnology                            IPFIX_BYTES_string
#define IPFIX_LENGTH_tunnelTechnology                         IPFIX_BYTES_string
#define IPFIX_LENGTH_encryptedTechnology                      IPFIX_BYTES_string
#define IPFIX_LENGTH_basicList                                IPFIX_BYTES_basicList
#define IPFIX_LENGTH_subTemplateList                          IPFIX_BYTES_subTemplateList
#define IPFIX_LENGTH_subTemplateMultiList                     IPFIX_BYTES_subTemplateMultiList
#define IPFIX_LENGTH_bgpValidityState                         IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_IPSecSPI                                 IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_greKey                                   IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_natType                                  IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_initiatorPackets                         IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_responderPackets                         IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_observationDomainName                    IPFIX_BYTES_string
#define IPFIX_LENGTH_selectionSequenceId                      IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_selectorId                               IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_informationElementId                     IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_selectorAlgorithm                        IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_samplingPacketInterval                   IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_samplingPacketSpace                      IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_samplingTimeInterval                     IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_samplingTimeSpace                        IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_samplingSize                             IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_samplingPopulation                       IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_samplingProbability                      IPFIX_BYTES_float64
#define IPFIX_LENGTH_dataLinkFrameSize                        IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_ipHeaderPacketSection                    IPFIX_BYTES_octetArray
#define IPFIX_LENGTH_ipPayloadPacketSection                   IPFIX_BYTES_octetArray
#define IPFIX_LENGTH_dataLinkFrameSection                     IPFIX_BYTES_octetArray
#define IPFIX_LENGTH_mplsLabelStackSection                    IPFIX_BYTES_octetArray
#define IPFIX_LENGTH_mplsPayloadPacketSection                 IPFIX_BYTES_octetArray
#define IPFIX_LENGTH_selectorIdTotalPktsObserved              IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_selectorIdTotalPktsSelected              IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_absoluteError                            IPFIX_BYTES_float64
#define IPFIX_LENGTH_relativeError                            IPFIX_BYTES_float64
#define IPFIX_LENGTH_observationTimeSeconds                   IPFIX_BYTES_dateTimeSeconds
#define IPFIX_LENGTH_observationTimeMilliseconds              IPFIX_BYTES_dateTimeMilliseconds
#define IPFIX_LENGTH_observationTimeMicroseconds              IPFIX_BYTES_dateTimeMicroseconds
#define IPFIX_LENGTH_observationTimeNanoseconds               IPFIX_BYTES_dateTimeNanoseconds
#define IPFIX_LENGTH_digestHashValue                          IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_hashIPPayloadOffset                      IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_hashIPPayloadSize                        IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_hashOutputRangeMin                       IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_hashOutputRangeMax                       IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_hashSelectedRangeMin                     IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_hashSelectedRangeMax                     IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_hashDigestOutput                         IPFIX_BYTES_boolean
#define IPFIX_LENGTH_hashInitialiserValue                     IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_selectorName                             IPFIX_BYTES_string
#define IPFIX_LENGTH_upperCILimit                             IPFIX_BYTES_float64
#define IPFIX_LENGTH_lowerCILimit                             IPFIX_BYTES_float64
#define IPFIX_LENGTH_confidenceLevel                          IPFIX_BYTES_float64
#define IPFIX_LENGTH_informationElementDataType               IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_informationElementDescription            IPFIX_BYTES_string
#define IPFIX_LENGTH_informationElementName                   IPFIX_BYTES_string
#define IPFIX_LENGTH_informationElementRangeBegin             IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_informationElementRangeEnd               IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_informationElementSemantics              IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_informationElementUnits                  IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_privateEnterpriseNumber                  IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_virtualStationInterfaceId                IPFIX_BYTES_octetArray
#define IPFIX_LENGTH_virtualStationInterfaceName              IPFIX_BYTES_string
#define IPFIX_LENGTH_virtualStationUUID                       IPFIX_BYTES_octetArray
#define IPFIX_LENGTH_virtualStationName                       IPFIX_BYTES_string
#define IPFIX_LENGTH_layer2SegmentId                          IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_layer2OctetDeltaCount                    IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_layer2OctetTotalCount                    IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_ingressUnicastPacketTotalCount           IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_ingressMulticastPacketTotalCount         IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_ingressBroadcastPacketTotalCount         IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_egressUnicastPacketTotalCount            IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_egressBroadcastPacketTotalCount          IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_monitoringIntervalStartMilliSeconds      IPFIX_BYTES_dateTimeMilliseconds
#define IPFIX_LENGTH_monitoringIntervalEndMilliSeconds        IPFIX_BYTES_dateTimeMilliseconds
#define IPFIX_LENGTH_portRangeStart                           IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_portRangeEnd                             IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_portRangeStepSize                        IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_portRangeNumPorts                        IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_staMacAddress                            IPFIX_BYTES_macAddress
#define IPFIX_LENGTH_staIPv4Address                           IPFIX_BYTES_ipv4Address
#define IPFIX_LENGTH_wtpMacAddress                            IPFIX_BYTES_macAddress
#define IPFIX_LENGTH_ingressInterfaceType                     IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_egressInterfaceType                      IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_rtpSequenceNumber                        IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_userName                                 IPFIX_BYTES_string
#define IPFIX_LENGTH_applicationCategoryName                  IPFIX_BYTES_string
#define IPFIX_LENGTH_applicationSubCategoryName               IPFIX_BYTES_string
#define IPFIX_LENGTH_applicationGroupName                     IPFIX_BYTES_string
#define IPFIX_LENGTH_originalFlowsPresent                     IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_originalFlowsInitiated                   IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_originalFlowsCompleted                   IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_distinctCountOfSourceIPAddress           IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_distinctCountOfDestinationIPAddress      IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_distinctCountOfSourceIPv4Address         IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_distinctCountOfDestinationIPv4Address    IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_distinctCountOfSourceIPv6Address         IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_distinctCountOfDestinationIPv6Address    IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_valueDistributionMethod                  IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_rfc3550JitterMilliseconds                IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_rfc3550JitterMicroseconds                IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_rfc3550JitterNanoseconds                 IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_dot1qDEI                                 IPFIX_BYTES_boolean
#define IPFIX_LENGTH_dot1qCustomerDEI                         IPFIX_BYTES_boolean
#define IPFIX_LENGTH_flowSelectorAlgorithm                    IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_flowSelectedOctetDeltaCount              IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_flowSelectedPacketDeltaCount             IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_flowSelectedFlowDeltaCount               IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_selectorIDTotalFlowsObserved             IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_selectorIDTotalFlowsSelected             IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_samplingFlowInterval                     IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_samplingFlowSpacing                      IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_flowSamplingTimeInterval                 IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_flowSamplingTimeSpacing                  IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_hashFlowDomain                           IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_transportOctetDeltaCount                 IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_transportPacketDeltaCount                IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_originalExporterIPv4Address              IPFIX_BYTES_ipv4Address
#define IPFIX_LENGTH_originalExporterIPv6Address              IPFIX_BYTES_ipv6Address
#define IPFIX_LENGTH_originalObservationDomainId              IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_intermediateProcessId                    IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_ignoredDataRecordTotalCount              IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_dataLinkFrameType                        IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_sectionOffset                            IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_sectionExportedOctets                    IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_dot1qServiceInstanceTag                  IPFIX_BYTES_octetArray
#define IPFIX_LENGTH_dot1qServiceInstanceId                   IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_dot1qServiceInstancePriority             IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_dot1qCustomerSourceMacAddress            IPFIX_BYTES_macAddress
#define IPFIX_LENGTH_dot1qCustomerDestinationMacAddress       IPFIX_BYTES_macAddress
#define IPFIX_LENGTH_postLayer2OctetDeltaCount                IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_postMCastLayer2OctetDeltaCount           IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_postLayer2OctetTotalCount                IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_postMCastLayer2OctetTotalCount           IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_minimumLayer2TotalLength                 IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_maximumLayer2TotalLength                 IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_droppedLayer2OctetDeltaCount             IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_droppedLayer2OctetTotalCount             IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_ignoredLayer2OctetTotalCount             IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_notSentLayer2OctetTotalCount             IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_layer2OctetDeltaSumOfSquares             IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_layer2OctetTotalSumOfSquares             IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_layer2FrameDeltaCount                    IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_layer2FrameTotalCount                    IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_pseudoWireDestinationIPv4Address         IPFIX_BYTES_ipv4Address
#define IPFIX_LENGTH_ignoredLayer2FrameTotalCount             IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_mibObjectValueInteger                    IPFIX_BYTES_signed32
#define IPFIX_LENGTH_mibObjectValueOctetString                IPFIX_BYTES_octetArray
#define IPFIX_LENGTH_mibObjectValueOID                        IPFIX_BYTES_octetArray
#define IPFIX_LENGTH_mibObjectValueBits                       IPFIX_BYTES_octetArray
#define IPFIX_LENGTH_mibObjectValueIPAddress                  IPFIX_BYTES_ipv4Address
#define IPFIX_LENGTH_mibObjectValueCounter                    IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_mibObjectValueGauge                      IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_mibObjectValueTimeTicks                  IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_mibObjectValueUnsigned                   IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_mibObjectValueTable                      IPFIX_BYTES_subTemplateList
#define IPFIX_LENGTH_mibObjectValueRow                        IPFIX_BYTES_subTemplateList
#define IPFIX_LENGTH_mibObjectIdentifier                      IPFIX_BYTES_octetArray
#define IPFIX_LENGTH_mibSubIdentifier                         IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_mibIndexIndicator                        IPFIX_BYTES_unsigned64
#define IPFIX_LENGTH_mibCaptureTimeSemantics                  IPFIX_BYTES_unsigned8
#define IPFIX_LENGTH_mibContextEngineID                       IPFIX_BYTES_octetArray
#define IPFIX_LENGTH_mibContextName                           IPFIX_BYTES_string
#define IPFIX_LENGTH_mibObjectName                            IPFIX_BYTES_string
#define IPFIX_LENGTH_mibObjectDescription                     IPFIX_BYTES_string
#define IPFIX_LENGTH_mibObjectSyntax                          IPFIX_BYTES_string
#define IPFIX_LENGTH_mibModuleName                            IPFIX_BYTES_string
#define IPFIX_LENGTH_mobileIMSI                               IPFIX_BYTES_string
#define IPFIX_LENGTH_mobileMSISDN                             IPFIX_BYTES_string
#define IPFIX_LENGTH_httpStatusCode                           IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_sourceTransportPortsLimit                IPFIX_BYTES_unsigned16
#define IPFIX_LENGTH_httpRequestMethod                        IPFIX_BYTES_string
#define IPFIX_LENGTH_httpRequestHost                          IPFIX_BYTES_string
#define IPFIX_LENGTH_httpRequestTarget                        IPFIX_BYTES_string
#define IPFIX_LENGTH_httpMessageVersion                       IPFIX_BYTES_string
#define IPFIX_LENGTH_natInstanceID                            IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_internalAddressRealm                     IPFIX_BYTES_octetArray
#define IPFIX_LENGTH_externalAddressRealm                     IPFIX_BYTES_octetArray
#define IPFIX_LENGTH_natQuotaExceededEvent                    IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_natThresholdEvent                        IPFIX_BYTES_unsigned32
#define IPFIX_LENGTH_httpUserAgent                            IPFIX_BYTES_string
#define IPFIX_LENGTH_httpContentType                          IPFIX_BYTES_string
#define IPFIX_LENGTH_httpReasonPhrase                         IPFIX_BYTES_string

#define IPFIX_DATA_TYPE_octetDeltaCount                          IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_packetDeltaCount                         IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_deltaFlowCount                           IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_protocolIdentifier                       IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_ipClassOfService                         IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_tcpControlBits                           IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_sourceTransportPort                      IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_sourceIPv4Address                        IPFIX_TYPE_ipv4Address
#define IPFIX_DATA_TYPE_sourceIPv4PrefixLength                   IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_ingressInterface                         IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_destinationTransportPort                 IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_destinationIPv4Address                   IPFIX_TYPE_ipv4Address
#define IPFIX_DATA_TYPE_destinationIPv4PrefixLength              IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_egressInterface                          IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_ipNextHopIPv4Address                     IPFIX_TYPE_ipv4Address
#define IPFIX_DATA_TYPE_bgpSourceAsNumber                        IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_bgpDestinationAsNumber                   IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_bgpNextHopIPv4Address                    IPFIX_TYPE_ipv4Address
#define IPFIX_DATA_TYPE_postMCastPacketDeltaCount                IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_postMCastOctetDeltaCount                 IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_flowEndSysUpTime                         IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_flowStartSysUpTime                       IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_postOctetDeltaCount                      IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_postPacketDeltaCount                     IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_minimumIpTotalLength                     IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_maximumIpTotalLength                     IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_sourceIPv6Address                        IPFIX_TYPE_ipv6Address
#define IPFIX_DATA_TYPE_destinationIPv6Address                   IPFIX_TYPE_ipv6Address
#define IPFIX_DATA_TYPE_sourceIPv6PrefixLength                   IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_destinationIPv6PrefixLength              IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_flowLabelIPv6                            IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_icmpTypeCodeIPv4                         IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_igmpType                                 IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_flowActiveTimeout                        IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_flowIdleTimeout                          IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_exportedOctetTotalCount                  IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_exportedMessageTotalCount                IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_exportedFlowRecordTotalCount             IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_sourceIPv4Prefix                         IPFIX_TYPE_ipv4Address
#define IPFIX_DATA_TYPE_destinationIPv4Prefix                    IPFIX_TYPE_ipv4Address
#define IPFIX_DATA_TYPE_mplsTopLabelType                         IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_mplsTopLabelIPv4Address                  IPFIX_TYPE_ipv4Address
#define IPFIX_DATA_TYPE_minimumTTL                               IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_maximumTTL                               IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_fragmentIdentification                   IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_postIpClassOfService                     IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_sourceMacAddress                         IPFIX_TYPE_macAddress
#define IPFIX_DATA_TYPE_postDestinationMacAddress                IPFIX_TYPE_macAddress
#define IPFIX_DATA_TYPE_vlanId                                   IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_postVlanId                               IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_ipVersion                                IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_flowDirection                            IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_ipNextHopIPv6Address                     IPFIX_TYPE_ipv6Address
#define IPFIX_DATA_TYPE_bgpNextHopIPv6Address                    IPFIX_TYPE_ipv6Address
#define IPFIX_DATA_TYPE_ipv6ExtensionHeaders                     IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_mplsTopLabelStackSection                 IPFIX_TYPE_octetArray
#define IPFIX_DATA_TYPE_mplsLabelStackSection2                   IPFIX_TYPE_octetArray
#define IPFIX_DATA_TYPE_mplsLabelStackSection3                   IPFIX_TYPE_octetArray
#define IPFIX_DATA_TYPE_mplsLabelStackSection4                   IPFIX_TYPE_octetArray
#define IPFIX_DATA_TYPE_mplsLabelStackSection5                   IPFIX_TYPE_octetArray
#define IPFIX_DATA_TYPE_mplsLabelStackSection6                   IPFIX_TYPE_octetArray
#define IPFIX_DATA_TYPE_mplsLabelStackSection7                   IPFIX_TYPE_octetArray
#define IPFIX_DATA_TYPE_mplsLabelStackSection8                   IPFIX_TYPE_octetArray
#define IPFIX_DATA_TYPE_mplsLabelStackSection9                   IPFIX_TYPE_octetArray
#define IPFIX_DATA_TYPE_mplsLabelStackSection10                  IPFIX_TYPE_octetArray
#define IPFIX_DATA_TYPE_destinationMacAddress                    IPFIX_TYPE_macAddress
#define IPFIX_DATA_TYPE_postSourceMacAddress                     IPFIX_TYPE_macAddress
#define IPFIX_DATA_TYPE_interfaceName                            IPFIX_TYPE_string
#define IPFIX_DATA_TYPE_interfaceDescription                     IPFIX_TYPE_string
#define IPFIX_DATA_TYPE_octetTotalCount                          IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_packetTotalCount                         IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_fragmentOffset                           IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_forwardingStatus                         IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_mplsVpnRouteDistinguisher                IPFIX_TYPE_octetArray
#define IPFIX_DATA_TYPE_mplsTopLabelPrefixLength                 IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_srcTrafficIndex                          IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_dstTrafficIndex                          IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_applicationDescription                   IPFIX_TYPE_string
#define IPFIX_DATA_TYPE_applicationId                            IPFIX_TYPE_octetArray
#define IPFIX_DATA_TYPE_applicationName                          IPFIX_TYPE_string
#define IPFIX_DATA_TYPE_postIpDiffServCodePoint                  IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_multicastReplicationFactor               IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_classificationEngineId                   IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_bgpNextAdjacentAsNumber                  IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_bgpPrevAdjacentAsNumber                  IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_exporterIPv4Address                      IPFIX_TYPE_ipv4Address
#define IPFIX_DATA_TYPE_exporterIPv6Address                      IPFIX_TYPE_ipv6Address
#define IPFIX_DATA_TYPE_droppedOctetDeltaCount                   IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_droppedPacketDeltaCount                  IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_droppedOctetTotalCount                   IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_droppedPacketTotalCount                  IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_flowEndReason                            IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_commonPropertiesId                       IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_observationPointId                       IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_icmpTypeCodeIPv6                         IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_mplsTopLabelIPv6Address                  IPFIX_TYPE_ipv6Address
#define IPFIX_DATA_TYPE_lineCardId                               IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_portId                                   IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_meteringProcessId                        IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_exportingProcessId                       IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_templateId                               IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_wlanChannelId                            IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_wlanSSID                                 IPFIX_TYPE_string
#define IPFIX_DATA_TYPE_flowId                                   IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_observationDomainId                      IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_flowStartSeconds                         IPFIX_TYPE_dateTimeSeconds
#define IPFIX_DATA_TYPE_flowEndSeconds                           IPFIX_TYPE_dateTimeSeconds
#define IPFIX_DATA_TYPE_flowStartMilliseconds                    IPFIX_TYPE_dateTimeMilliseconds
#define IPFIX_DATA_TYPE_flowEndMilliseconds                      IPFIX_TYPE_dateTimeMilliseconds
#define IPFIX_DATA_TYPE_flowStartMicroseconds                    IPFIX_TYPE_dateTimeMicroseconds
#define IPFIX_DATA_TYPE_flowEndMicroseconds                      IPFIX_TYPE_dateTimeMicroseconds
#define IPFIX_DATA_TYPE_flowStartNanoseconds                     IPFIX_TYPE_dateTimeNanoseconds
#define IPFIX_DATA_TYPE_flowEndNanoseconds                       IPFIX_TYPE_dateTimeNanoseconds
#define IPFIX_DATA_TYPE_flowStartDeltaMicroseconds               IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_flowEndDeltaMicroseconds                 IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_systemInitTimeMilliseconds               IPFIX_TYPE_dateTimeMilliseconds
#define IPFIX_DATA_TYPE_flowDurationMilliseconds                 IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_flowDurationMicroseconds                 IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_observedFlowTotalCount                   IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_ignoredPacketTotalCount                  IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_ignoredOctetTotalCount                   IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_notSentFlowTotalCount                    IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_notSentPacketTotalCount                  IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_notSentOctetTotalCount                   IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_destinationIPv6Prefix                    IPFIX_TYPE_ipv6Address
#define IPFIX_DATA_TYPE_sourceIPv6Prefix                         IPFIX_TYPE_ipv6Address
#define IPFIX_DATA_TYPE_postOctetTotalCount                      IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_postPacketTotalCount                     IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_flowKeyIndicator                         IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_postMCastPacketTotalCount                IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_postMCastOctetTotalCount                 IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_icmpTypeIPv4                             IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_icmpCodeIPv4                             IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_icmpTypeIPv6                             IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_icmpCodeIPv6                             IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_udpSourcePort                            IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_udpDestinationPort                       IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_tcpSourcePort                            IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_tcpDestinationPort                       IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_tcpSequenceNumber                        IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_tcpAcknowledgementNumber                 IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_tcpWindowSize                            IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_tcpUrgentPointer                         IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_tcpHeaderLength                          IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_ipHeaderLength                           IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_totalLengthIPv4                          IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_payloadLengthIPv6                        IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_ipTTL                                    IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_nextHeaderIPv6                           IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_mplsPayloadLength                        IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_ipDiffServCodePoint                      IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_ipPrecedence                             IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_fragmentFlags                            IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_octetDeltaSumOfSquares                   IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_octetTotalSumOfSquares                   IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_mplsTopLabelTTL                          IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_mplsLabelStackLength                     IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_mplsLabelStackDepth                      IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_mplsTopLabelExp                          IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_ipPayloadLength                          IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_udpMessageLength                         IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_isMulticast                              IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_ipv4IHL                                  IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_ipv4Options                              IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_tcpOptions                               IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_paddingOctets                            IPFIX_TYPE_octetArray
#define IPFIX_DATA_TYPE_collectorIPv4Address                     IPFIX_TYPE_ipv4Address
#define IPFIX_DATA_TYPE_collectorIPv6Address                     IPFIX_TYPE_ipv6Address
#define IPFIX_DATA_TYPE_exportInterface                          IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_exportProtocolVersion                    IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_exportTransportProtocol                  IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_collectorTransportPort                   IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_exporterTransportPort                    IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_tcpSynTotalCount                         IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_tcpFinTotalCount                         IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_tcpRstTotalCount                         IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_tcpPshTotalCount                         IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_tcpAckTotalCount                         IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_tcpUrgTotalCount                         IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_ipTotalLength                            IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_postNATSourceIPv4Address                 IPFIX_TYPE_ipv4Address
#define IPFIX_DATA_TYPE_postNATDestinationIPv4Address            IPFIX_TYPE_ipv4Address
#define IPFIX_DATA_TYPE_postNAPTSourceTransportPort              IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_postNAPTDestinationTransportPort         IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_natOriginatingAddressRealm               IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_natEvent                                 IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_initiatorOctets                          IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_responderOctets                          IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_firewallEvent                            IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_ingressVRFID                             IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_egressVRFID                              IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_VRFname                                  IPFIX_TYPE_string
#define IPFIX_DATA_TYPE_postMplsTopLabelExp                      IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_tcpWindowScale                           IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_biflowDirection                          IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_ethernetHeaderLength                     IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_ethernetPayloadLength                    IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_ethernetTotalLength                      IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_dot1qVlanId                              IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_dot1qPriority                            IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_dot1qCustomerVlanId                      IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_dot1qCustomerPriority                    IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_metroEvcId                               IPFIX_TYPE_string
#define IPFIX_DATA_TYPE_metroEvcType                             IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_pseudoWireId                             IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_pseudoWireType                           IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_pseudoWireControlWord                    IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_ingressPhysicalInterface                 IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_egressPhysicalInterface                  IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_postDot1qVlanId                          IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_postDot1qCustomerVlanId                  IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_ethernetType                             IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_postIpPrecedence                         IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_collectionTimeMilliseconds               IPFIX_TYPE_dateTimeMilliseconds
#define IPFIX_DATA_TYPE_exportSctpStreamId                       IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_maxExportSeconds                         IPFIX_TYPE_dateTimeSeconds
#define IPFIX_DATA_TYPE_maxFlowEndSeconds                        IPFIX_TYPE_dateTimeSeconds
#define IPFIX_DATA_TYPE_messageMD5Checksum                       IPFIX_TYPE_octetArray
#define IPFIX_DATA_TYPE_messageScope                             IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_minExportSeconds                         IPFIX_TYPE_dateTimeSeconds
#define IPFIX_DATA_TYPE_minFlowStartSeconds                      IPFIX_TYPE_dateTimeSeconds
#define IPFIX_DATA_TYPE_opaqueOctets                             IPFIX_TYPE_octetArray
#define IPFIX_DATA_TYPE_sessionScope                             IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_maxFlowEndMicroseconds                   IPFIX_TYPE_dateTimeMicroseconds
#define IPFIX_DATA_TYPE_maxFlowEndMilliseconds                   IPFIX_TYPE_dateTimeMilliseconds
#define IPFIX_DATA_TYPE_maxFlowEndNanoseconds                    IPFIX_TYPE_dateTimeNanoseconds
#define IPFIX_DATA_TYPE_minFlowStartMicroseconds                 IPFIX_TYPE_dateTimeMicroseconds
#define IPFIX_DATA_TYPE_minFlowStartMilliseconds                 IPFIX_TYPE_dateTimeMilliseconds
#define IPFIX_DATA_TYPE_minFlowStartNanoseconds                  IPFIX_TYPE_dateTimeNanoseconds
#define IPFIX_DATA_TYPE_collectorCertificate                     IPFIX_TYPE_octetArray
#define IPFIX_DATA_TYPE_exporterCertificate                      IPFIX_TYPE_octetArray
#define IPFIX_DATA_TYPE_dataRecordsReliability                   IPFIX_TYPE_boolean
#define IPFIX_DATA_TYPE_observationPointType                     IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_newConnectionDeltaCount                  IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_connectionSumDurationSeconds             IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_connectionTransactionId                  IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_postNATSourceIPv6Address                 IPFIX_TYPE_ipv6Address
#define IPFIX_DATA_TYPE_postNATDestinationIPv6Address            IPFIX_TYPE_ipv6Address
#define IPFIX_DATA_TYPE_natPoolId                                IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_natPoolName                              IPFIX_TYPE_string
#define IPFIX_DATA_TYPE_anonymizationFlags                       IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_anonymizationTechnique                   IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_informationElementIndex                  IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_p2pTechnology                            IPFIX_TYPE_string
#define IPFIX_DATA_TYPE_tunnelTechnology                         IPFIX_TYPE_string
#define IPFIX_DATA_TYPE_encryptedTechnology                      IPFIX_TYPE_string
#define IPFIX_DATA_TYPE_basicList                                IPFIX_TYPE_basicList
#define IPFIX_DATA_TYPE_subTemplateList                          IPFIX_TYPE_subTemplateList
#define IPFIX_DATA_TYPE_subTemplateMultiList                     IPFIX_TYPE_subTemplateMultiList
#define IPFIX_DATA_TYPE_bgpValidityState                         IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_IPSecSPI                                 IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_greKey                                   IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_natType                                  IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_initiatorPackets                         IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_responderPackets                         IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_observationDomainName                    IPFIX_TYPE_string
#define IPFIX_DATA_TYPE_selectionSequenceId                      IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_selectorId                               IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_informationElementId                     IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_selectorAlgorithm                        IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_samplingPacketInterval                   IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_samplingPacketSpace                      IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_samplingTimeInterval                     IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_samplingTimeSpace                        IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_samplingSize                             IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_samplingPopulation                       IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_samplingProbability                      IPFIX_TYPE_float64
#define IPFIX_DATA_TYPE_dataLinkFrameSize                        IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_ipHeaderPacketSection                    IPFIX_TYPE_octetArray
#define IPFIX_DATA_TYPE_ipPayloadPacketSection                   IPFIX_TYPE_octetArray
#define IPFIX_DATA_TYPE_dataLinkFrameSection                     IPFIX_TYPE_octetArray
#define IPFIX_DATA_TYPE_mplsLabelStackSection                    IPFIX_TYPE_octetArray
#define IPFIX_DATA_TYPE_mplsPayloadPacketSection                 IPFIX_TYPE_octetArray
#define IPFIX_DATA_TYPE_selectorIdTotalPktsObserved              IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_selectorIdTotalPktsSelected              IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_absoluteError                            IPFIX_TYPE_float64
#define IPFIX_DATA_TYPE_relativeError                            IPFIX_TYPE_float64
#define IPFIX_DATA_TYPE_observationTimeSeconds                   IPFIX_TYPE_dateTimeSeconds
#define IPFIX_DATA_TYPE_observationTimeMilliseconds              IPFIX_TYPE_dateTimeMilliseconds
#define IPFIX_DATA_TYPE_observationTimeMicroseconds              IPFIX_TYPE_dateTimeMicroseconds
#define IPFIX_DATA_TYPE_observationTimeNanoseconds               IPFIX_TYPE_dateTimeNanoseconds
#define IPFIX_DATA_TYPE_digestHashValue                          IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_hashIPPayloadOffset                      IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_hashIPPayloadSize                        IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_hashOutputRangeMin                       IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_hashOutputRangeMax                       IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_hashSelectedRangeMin                     IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_hashSelectedRangeMax                     IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_hashDigestOutput                         IPFIX_TYPE_boolean
#define IPFIX_DATA_TYPE_hashInitialiserValue                     IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_selectorName                             IPFIX_TYPE_string
#define IPFIX_DATA_TYPE_upperCILimit                             IPFIX_TYPE_float64
#define IPFIX_DATA_TYPE_lowerCILimit                             IPFIX_TYPE_float64
#define IPFIX_DATA_TYPE_confidenceLevel                          IPFIX_TYPE_float64
#define IPFIX_DATA_TYPE_informationElementDataType               IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_informationElementDescription            IPFIX_TYPE_string
#define IPFIX_DATA_TYPE_informationElementName                   IPFIX_TYPE_string
#define IPFIX_DATA_TYPE_informationElementRangeBegin             IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_informationElementRangeEnd               IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_informationElementSemantics              IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_informationElementUnits                  IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_privateEnterpriseNumber                  IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_virtualStationInterfaceId                IPFIX_TYPE_octetArray
#define IPFIX_DATA_TYPE_virtualStationInterfaceName              IPFIX_TYPE_string
#define IPFIX_DATA_TYPE_virtualStationUUID                       IPFIX_TYPE_octetArray
#define IPFIX_DATA_TYPE_virtualStationName                       IPFIX_TYPE_string
#define IPFIX_DATA_TYPE_layer2SegmentId                          IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_layer2OctetDeltaCount                    IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_layer2OctetTotalCount                    IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_ingressUnicastPacketTotalCount           IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_ingressMulticastPacketTotalCount         IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_ingressBroadcastPacketTotalCount         IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_egressUnicastPacketTotalCount            IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_egressBroadcastPacketTotalCount          IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_monitoringIntervalStartMilliSeconds      IPFIX_TYPE_dateTimeMilliseconds
#define IPFIX_DATA_TYPE_monitoringIntervalEndMilliSeconds        IPFIX_TYPE_dateTimeMilliseconds
#define IPFIX_DATA_TYPE_portRangeStart                           IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_portRangeEnd                             IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_portRangeStepSize                        IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_portRangeNumPorts                        IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_staMacAddress                            IPFIX_TYPE_macAddress
#define IPFIX_DATA_TYPE_staIPv4Address                           IPFIX_TYPE_ipv4Address
#define IPFIX_DATA_TYPE_wtpMacAddress                            IPFIX_TYPE_macAddress
#define IPFIX_DATA_TYPE_ingressInterfaceType                     IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_egressInterfaceType                      IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_rtpSequenceNumber                        IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_userName                                 IPFIX_TYPE_string
#define IPFIX_DATA_TYPE_applicationCategoryName                  IPFIX_TYPE_string
#define IPFIX_DATA_TYPE_applicationSubCategoryName               IPFIX_TYPE_string
#define IPFIX_DATA_TYPE_applicationGroupName                     IPFIX_TYPE_string
#define IPFIX_DATA_TYPE_originalFlowsPresent                     IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_originalFlowsInitiated                   IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_originalFlowsCompleted                   IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_distinctCountOfSourceIPAddress           IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_distinctCountOfDestinationIPAddress      IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_distinctCountOfSourceIPv4Address         IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_distinctCountOfDestinationIPv4Address    IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_distinctCountOfSourceIPv6Address         IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_distinctCountOfDestinationIPv6Address    IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_valueDistributionMethod                  IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_rfc3550JitterMilliseconds                IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_rfc3550JitterMicroseconds                IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_rfc3550JitterNanoseconds                 IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_dot1qDEI                                 IPFIX_TYPE_boolean
#define IPFIX_DATA_TYPE_dot1qCustomerDEI                         IPFIX_TYPE_boolean
#define IPFIX_DATA_TYPE_flowSelectorAlgorithm                    IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_flowSelectedOctetDeltaCount              IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_flowSelectedPacketDeltaCount             IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_flowSelectedFlowDeltaCount               IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_selectorIDTotalFlowsObserved             IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_selectorIDTotalFlowsSelected             IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_samplingFlowInterval                     IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_samplingFlowSpacing                      IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_flowSamplingTimeInterval                 IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_flowSamplingTimeSpacing                  IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_hashFlowDomain                           IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_transportOctetDeltaCount                 IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_transportPacketDeltaCount                IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_originalExporterIPv4Address              IPFIX_TYPE_ipv4Address
#define IPFIX_DATA_TYPE_originalExporterIPv6Address              IPFIX_TYPE_ipv6Address
#define IPFIX_DATA_TYPE_originalObservationDomainId              IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_intermediateProcessId                    IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_ignoredDataRecordTotalCount              IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_dataLinkFrameType                        IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_sectionOffset                            IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_sectionExportedOctets                    IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_dot1qServiceInstanceTag                  IPFIX_TYPE_octetArray
#define IPFIX_DATA_TYPE_dot1qServiceInstanceId                   IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_dot1qServiceInstancePriority             IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_dot1qCustomerSourceMacAddress            IPFIX_TYPE_macAddress
#define IPFIX_DATA_TYPE_dot1qCustomerDestinationMacAddress       IPFIX_TYPE_macAddress
#define IPFIX_DATA_TYPE_postLayer2OctetDeltaCount                IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_postMCastLayer2OctetDeltaCount           IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_postLayer2OctetTotalCount                IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_postMCastLayer2OctetTotalCount           IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_minimumLayer2TotalLength                 IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_maximumLayer2TotalLength                 IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_droppedLayer2OctetDeltaCount             IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_droppedLayer2OctetTotalCount             IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_ignoredLayer2OctetTotalCount             IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_notSentLayer2OctetTotalCount             IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_layer2OctetDeltaSumOfSquares             IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_layer2OctetTotalSumOfSquares             IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_layer2FrameDeltaCount                    IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_layer2FrameTotalCount                    IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_pseudoWireDestinationIPv4Address         IPFIX_TYPE_ipv4Address
#define IPFIX_DATA_TYPE_ignoredLayer2FrameTotalCount             IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_mibObjectValueInteger                    IPFIX_TYPE_signed32
#define IPFIX_DATA_TYPE_mibObjectValueOctetString                IPFIX_TYPE_octetArray
#define IPFIX_DATA_TYPE_mibObjectValueOID                        IPFIX_TYPE_octetArray
#define IPFIX_DATA_TYPE_mibObjectValueBits                       IPFIX_TYPE_octetArray
#define IPFIX_DATA_TYPE_mibObjectValueIPAddress                  IPFIX_TYPE_ipv4Address
#define IPFIX_DATA_TYPE_mibObjectValueCounter                    IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_mibObjectValueGauge                      IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_mibObjectValueTimeTicks                  IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_mibObjectValueUnsigned                   IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_mibObjectValueTable                      IPFIX_TYPE_subTemplateList
#define IPFIX_DATA_TYPE_mibObjectValueRow                        IPFIX_TYPE_subTemplateList
#define IPFIX_DATA_TYPE_mibObjectIdentifier                      IPFIX_TYPE_octetArray
#define IPFIX_DATA_TYPE_mibSubIdentifier                         IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_mibIndexIndicator                        IPFIX_TYPE_unsigned64
#define IPFIX_DATA_TYPE_mibCaptureTimeSemantics                  IPFIX_TYPE_unsigned8
#define IPFIX_DATA_TYPE_mibContextEngineID                       IPFIX_TYPE_octetArray
#define IPFIX_DATA_TYPE_mibContextName                           IPFIX_TYPE_string
#define IPFIX_DATA_TYPE_mibObjectName                            IPFIX_TYPE_string
#define IPFIX_DATA_TYPE_mibObjectDescription                     IPFIX_TYPE_string
#define IPFIX_DATA_TYPE_mibObjectSyntax                          IPFIX_TYPE_string
#define IPFIX_DATA_TYPE_mibModuleName                            IPFIX_TYPE_string
#define IPFIX_DATA_TYPE_mobileIMSI                               IPFIX_TYPE_string
#define IPFIX_DATA_TYPE_mobileMSISDN                             IPFIX_TYPE_string
#define IPFIX_DATA_TYPE_httpStatusCode                           IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_sourceTransportPortsLimit                IPFIX_TYPE_unsigned16
#define IPFIX_DATA_TYPE_httpRequestMethod                        IPFIX_TYPE_string
#define IPFIX_DATA_TYPE_httpRequestHost                          IPFIX_TYPE_string
#define IPFIX_DATA_TYPE_httpRequestTarget                        IPFIX_TYPE_string
#define IPFIX_DATA_TYPE_httpMessageVersion                       IPFIX_TYPE_string
#define IPFIX_DATA_TYPE_natInstanceID                            IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_internalAddressRealm                     IPFIX_TYPE_octetArray
#define IPFIX_DATA_TYPE_externalAddressRealm                     IPFIX_TYPE_octetArray
#define IPFIX_DATA_TYPE_natQuotaExceededEvent                    IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_natThresholdEvent                        IPFIX_TYPE_unsigned32
#define IPFIX_DATA_TYPE_httpUserAgent                            IPFIX_TYPE_string
#define IPFIX_DATA_TYPE_httpContentType                          IPFIX_TYPE_string
#define IPFIX_DATA_TYPE_httpReasonPhrase                         IPFIX_TYPE_string

#define IPFIX_STRUCTURED_TYPE_SEMANTIC_noneOf                         0x00
#define IPFIX_STRUCTURED_TYPE_SEMANTIC_exactlyOneOf                   0x01
#define IPFIX_STRUCTURED_TYPE_SEMANTIC_oneOrMoreOf                    0x02
#define IPFIX_STRUCTURED_TYPE_SEMANTIC_allOf                          0x03
#define IPFIX_STRUCTURED_TYPE_SEMANTIC_ordered                        0x04
#define IPFIX_STRUCTURED_TYPE_SEMANTIC_undefined                      0xFF


#endif
